/* Indicator.c generated by valac 0.56.17, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*
* Copyright 2015-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "sound.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <libnotify/notify.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <canberra.h>
#include <wingpanel.h>
#include <gio/gio.h>
#include <pulse/pulseaudio.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <locale.h>
#include <canberra-gtk.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_INDICATOR_0_PROPERTY,
	SOUND_INDICATOR_IS_IN_SESSION_PROPERTY,
	SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY,
	SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY,
	SOUND_INDICATOR_VOLUME_STEP_PROPERTY,
	SOUND_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* sound_indicator_properties[SOUND_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _ca_proplist_destroy0(var) ((var == NULL) ? NULL : (var = (ca_proplist_destroy (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SoundIndicatorPrivate {
	gboolean _is_in_session;
	gboolean _natural_scroll_touchpad;
	gboolean _natural_scroll_mouse;
	gint _volume_step;
	DisplayWidget* display_widget;
	GtkBox* main_box;
	SoundWidgetsPlayerList* mpris;
	SoundWidgetsScale* volume_scale;
	SoundWidgetsScale* mic_scale;
	SoundWidgetsDeviceManagerWidget* output_device_manager;
	SoundWidgetsDeviceManagerWidget* input_device_manager;
	GtkSeparator* mic_separator;
	NotifyNotification* notification;
	SoundServicesVolumeControlPulse* volume_control;
	ShellKeyGrabber* key_grabber;
	gulong key_grabber_id;
	GeeHashMultiMap* saved_action_ids;
	gboolean open;
	gboolean mute_blocks_sound;
	guint sound_was_blocked_timeout_id;
	gdouble max_volume;
	ca_context* ca_context;
	gdouble total_x_delta;
	gdouble total_y_delta;
	guint notify_timeout_id;
};

struct _Block1Data {
	int _ref_count_;
	SoundIndicator* self;
	gboolean is_mic;
};

static gint SoundIndicator_private_offset;
static gpointer sound_indicator_parent_class = NULL;
GSettings* sound_indicator_settings = NULL;

static void sound_indicator_on_watch (SoundIndicator* self,
                               GDBusConnection* connection);
static void __lambda56_ (SoundIndicator* self,
                  GObject* obj,
                  GAsyncResult* res);
static void sound_indicator_setup_grabs (SoundIndicator* self);
static void ___lambda56__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void sound_indicator_on_unwatch (SoundIndicator* self,
                                 GDBusConnection* connection);
static void sound_indicator_ungrab_keybindings (SoundIndicator* self);
static void _vala_array_add1 (Accelerator* * array,
                       gint* length,
                       gint* size,
                       const Accelerator* value);
static void _vala_array_add2 (Accelerator* * array,
                       gint* length,
                       gint* size,
                       const Accelerator* value);
static void _vala_array_add3 (Accelerator* * array,
                       gint* length,
                       gint* size,
                       const Accelerator* value);
static void _vala_Accelerator_array_free (Accelerator * array,
                                   gssize array_length);
static void sound_indicator_on_accelerator_activated (SoundIndicator* self,
                                               guint action,
                                               GHashTable* parameters_dict);
static void _sound_indicator_on_accelerator_activated_shell_key_grabber_accelerator_activated (ShellKeyGrabber* _sender,
                                                                                        guint action,
                                                                                        GHashTable* parameters_dict,
                                                                                        gpointer self);
static void sound_indicator_handle_change (SoundIndicator* self,
                                    gdouble change,
                                    gboolean is_mic);
static void sound_indicator_notify_change (SoundIndicator* self,
                                    gboolean is_mic);
static void sound_indicator_set_max_volume (SoundIndicator* self);
static void sound_indicator_on_volume_change (SoundIndicator* self);
static const gchar* sound_indicator_get_volume_icon (SoundIndicator* self,
                                              gdouble volume);
static void sound_indicator_on_mic_volume_change (SoundIndicator* self);
static void sound_indicator_on_mute_change (SoundIndicator* self);
static void sound_indicator_on_mic_mute_change (SoundIndicator* self);
static void sound_indicator_on_is_playing_change (SoundIndicator* self);
static gboolean ____lambda58_ (SoundIndicator* self);
static gboolean _____lambda58__gsource_func (gpointer self);
static void sound_indicator_on_volume_icon_scroll_event (SoundIndicator* self,
                                                  GdkEventScroll* e);
static gboolean sound_indicator_handle_scroll_event (SoundIndicator* self,
                                              GdkEventScroll* e,
                                              gdouble* dir);
static void sound_indicator_on_mic_icon_scroll_event (SoundIndicator* self,
                                               GdkEventScroll* e);
static void sound_indicator_update_mic_visibility (SoundIndicator* self);
static void sound_indicator_on_volume_switch_change (SoundIndicator* self);
static void sound_indicator_on_mic_switch_change (SoundIndicator* self);
static GtkWidget* sound_indicator_real_get_display_widget (WingpanelIndicator* base);
static GtkWidget* sound_indicator_real_get_widget (WingpanelIndicator* base);
static void _sound_indicator_on_mic_switch_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void ___lambda59_ (SoundIndicator* self);
static void ____lambda59__gtk_range_value_changed (GtkRange* _sender,
                                            gpointer self);
static gboolean ___lambda60_ (SoundIndicator* self);
static gboolean ____lambda60__gtk_widget_button_release_event (GtkWidget* _sender,
                                                        GdkEventButton* event,
                                                        gpointer self);
static gboolean ___lambda61_ (SoundIndicator* self,
                       GdkEventScroll* e);
static gboolean ____lambda61__gtk_widget_scroll_event (GtkWidget* _sender,
                                                GdkEventScroll* event,
                                                gpointer self);
static void ___lambda62_ (SoundIndicator* self);
static void ____lambda62__sound_widgets_player_list_close (SoundWidgetsPlayerList* _sender,
                                                    gpointer self);
static void ___lambda63_ (SoundIndicator* self);
static void sound_indicator_show_settings (SoundIndicator* self);
static void ____lambda63__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void ___lambda64_ (SoundIndicator* self);
static void ____lambda64__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static gboolean ___lambda65_ (SoundIndicator* self,
                       GdkEventButton* e);
static gboolean ____lambda65__gtk_widget_button_release_event (GtkWidget* _sender,
                                                        GdkEventButton* event,
                                                        gpointer self);
static gboolean ___lambda66_ (SoundIndicator* self,
                       GdkEventScroll* e);
static gboolean ____lambda66__gtk_widget_scroll_event (GtkWidget* _sender,
                                                GdkEventScroll* event,
                                                gpointer self);
static void _sound_indicator_on_volume_switch_change_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void ___lambda67_ (SoundIndicator* self);
static void ____lambda67__gtk_range_value_changed (GtkRange* _sender,
                                            gpointer self);
static void sound_indicator_real_opened (WingpanelIndicator* base);
static void sound_indicator_real_closed (WingpanelIndicator* base);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda57_ (Block1Data* _data1_);
static gboolean sound_indicator_show_notification (SoundIndicator* self,
                                            gboolean is_mic);
static gboolean ___lambda57__gsource_func (gpointer self);
static void sound_indicator_update_tooltip (SoundIndicator* self);
static GObject * sound_indicator_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _sound_indicator_on_volume_change_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void _sound_indicator_on_mic_volume_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _sound_indicator_on_mute_change_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator_on_mic_mute_change_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _sound_indicator_on_is_playing_change_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static void _sound_indicator_update_mic_visibility_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void _sound_indicator_update_tooltip_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator_set_max_volume_g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void _sound_indicator___lambda68_ (SoundIndicator* self,
                                   GdkEventButton* e);
static void __sound_indicator___lambda68__display_widget_volume_press_event (DisplayWidget* _sender,
                                                                      GdkEventButton* e,
                                                                      gpointer self);
static void _sound_indicator___lambda69_ (SoundIndicator* self,
                                   GdkEventButton* e);
static void __sound_indicator___lambda69__display_widget_mic_press_event (DisplayWidget* _sender,
                                                                   GdkEventButton* e,
                                                                   gpointer self);
static void _sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event (DisplayWidget* _sender,
                                                                                      GdkEventScroll* e,
                                                                                      gpointer self);
static void _sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event (DisplayWidget* _sender,
                                                                                GdkEventScroll* e,
                                                                                gpointer self);
static void _sound_indicator_on_watch_gbus_name_appeared_callback (GDBusConnection* connection,
                                                            const gchar* name,
                                                            const gchar* name_owner,
                                                            gpointer self);
static void _sound_indicator_on_unwatch_gbus_name_vanished_callback (GDBusConnection* connection,
                                                              const gchar* name,
                                                              gpointer self);
static void _sound_indicator___lambda70_ (SoundIndicator* self,
                                   const gchar* key);
static void __sound_indicator___lambda70__g_settings_changed (GSettings* _sender,
                                                       const gchar* key,
                                                       gpointer self);
static void sound_indicator_finalize (GObject * obj);
static GType sound_indicator_get_type_once (void);
static void _vala_sound_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_sound_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
sound_indicator_get_instance_private (SoundIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, SoundIndicator_private_offset);
}

SoundIndicator*
sound_indicator_construct (GType object_type,
                           gboolean is_in_session)
{
	SoundIndicator * self = NULL;
#line 54 "../src/Indicator.vala"
	self = (SoundIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_SOUND, "is-in-session", is_in_session, NULL);
#line 53 "../src/Indicator.vala"
	return self;
#line 309 "Indicator.c"
}

SoundIndicator*
sound_indicator_new (gboolean is_in_session)
{
#line 53 "../src/Indicator.vala"
	return sound_indicator_construct (SOUND_TYPE_INDICATOR, is_in_session);
#line 317 "Indicator.c"
}

static void
__lambda56_ (SoundIndicator* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 156 "../src/Indicator.vala"
	g_return_if_fail (res != NULL);
#line 328 "Indicator.c"
	{
		ShellKeyGrabber* _tmp0_ = NULL;
		ShellKeyGrabber* _tmp1_;
		ShellKeyGrabber* _tmp2_;
		ShellKeyGrabber* _tmp3_;
#line 158 "../src/Indicator.vala"
		_tmp1_ = g_async_result_get_source_object (res);
#line 158 "../src/Indicator.vala"
		_tmp2_ = (ShellKeyGrabber*) g_async_initable_new_finish ((GAsyncInitable *) _tmp1_, res, &_inner_error0_);
#line 158 "../src/Indicator.vala"
		g_object_unref (_tmp1_);
#line 158 "../src/Indicator.vala"
		_tmp0_ = (ShellKeyGrabber*) _tmp2_;
#line 158 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 344 "Indicator.c"
			goto __catch0_g_error;
		}
#line 158 "../src/Indicator.vala"
		_tmp3_ = _tmp0_;
#line 158 "../src/Indicator.vala"
		_tmp0_ = NULL;
#line 158 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->key_grabber);
#line 158 "../src/Indicator.vala"
		self->priv->key_grabber = _tmp3_;
#line 159 "../src/Indicator.vala"
		sound_indicator_setup_grabs (self);
#line 157 "../src/Indicator.vala"
		_g_object_unref0 (_tmp0_);
#line 359 "Indicator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 157 "../src/Indicator.vala"
		e = _inner_error0_;
#line 157 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 161 "../src/Indicator.vala"
		_tmp4_ = e;
#line 161 "../src/Indicator.vala"
		_tmp5_ = _tmp4_->message;
#line 161 "../src/Indicator.vala"
		g_critical ("Indicator.vala:161: %s", _tmp5_);
#line 162 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->key_grabber);
#line 162 "../src/Indicator.vala"
		self->priv->key_grabber = NULL;
#line 157 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 383 "Indicator.c"
	}
	__finally0:
#line 157 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 157 "../src/Indicator.vala"
		return;
#line 394 "Indicator.c"
	}
}

static void
___lambda56__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 154 "../src/Indicator.vala"
	__lambda56_ ((SoundIndicator*) self, source_object, res);
#line 154 "../src/Indicator.vala"
	g_object_unref (self);
#line 407 "Indicator.c"
}

static void
sound_indicator_on_watch (SoundIndicator* self,
                          GDBusConnection* connection)
{
	GError* _inner_error0_ = NULL;
#line 153 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/Indicator.vala"
	g_return_if_fail (connection != NULL);
#line 154 "../src/Indicator.vala"
	g_async_initable_new_async (TYPE_SHELL_KEY_GRABBER_PROXY, 0, NULL, ___lambda56__gasync_ready_callback, g_object_ref (self), "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", "org.gnome.Shell", "g-connection", connection, "g-object-path", "/org/gnome/Shell", "g-interface-name", "org.gnome.Shell", NULL);
#line 421 "Indicator.c"
}

static void
sound_indicator_on_unwatch (SoundIndicator* self,
                            GDBusConnection* connection)
{
#line 168 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/Indicator.vala"
	g_return_if_fail (connection != NULL);
#line 169 "../src/Indicator.vala"
	if (self->priv->key_grabber_id != ((gulong) 0)) {
#line 434 "Indicator.c"
		ShellKeyGrabber* _tmp0_;
#line 170 "../src/Indicator.vala"
		_tmp0_ = self->priv->key_grabber;
#line 170 "../src/Indicator.vala"
		g_signal_handler_disconnect ((GObject*) _tmp0_, self->priv->key_grabber_id);
#line 171 "../src/Indicator.vala"
		self->priv->key_grabber_id = (gulong) 0;
#line 442 "Indicator.c"
	}
#line 173 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->key_grabber);
#line 173 "../src/Indicator.vala"
	self->priv->key_grabber = NULL;
#line 174 "../src/Indicator.vala"
	g_critical ("Indicator.vala:174: Lost connection to org.gnome.Shell");
#line 450 "Indicator.c"
}

static void
sound_indicator_ungrab_keybindings (SoundIndicator* self)
{
	ShellKeyGrabber* _tmp0_;
	guint* actions = NULL;
	GeeHashMultiMap* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gint _tmp4_ = 0;
	gpointer* _tmp5_;
	guint* _tmp6_;
	gint _tmp6__length1;
	gint actions_length1;
	gint _actions_size_;
	GError* _inner_error0_ = NULL;
#line 177 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/Indicator.vala"
	_tmp0_ = self->priv->key_grabber;
#line 177 "../src/Indicator.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "key_grabber != null");
#line 178 "../src/Indicator.vala"
	_tmp1_ = self->priv->saved_action_ids;
#line 178 "../src/Indicator.vala"
	_tmp2_ = gee_multi_map_get_values ((GeeMultiMap*) _tmp1_);
#line 178 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 178 "../src/Indicator.vala"
	_tmp5_ = gee_collection_to_array (_tmp3_, &_tmp4_);
#line 178 "../src/Indicator.vala"
	_tmp6_ = _tmp5_;
#line 178 "../src/Indicator.vala"
	_tmp6__length1 = _tmp4_;
#line 178 "../src/Indicator.vala"
	_g_object_unref0 (_tmp3_);
#line 178 "../src/Indicator.vala"
	actions = _tmp6_;
#line 178 "../src/Indicator.vala"
	actions_length1 = _tmp6__length1;
#line 178 "../src/Indicator.vala"
	_actions_size_ = actions_length1;
#line 494 "Indicator.c"
	{
		ShellKeyGrabber* _tmp7_;
#line 181 "../src/Indicator.vala"
		_tmp7_ = self->priv->key_grabber;
#line 181 "../src/Indicator.vala"
		shell_key_grabber_ungrab_accelerators (_tmp7_, actions, (gint) actions_length1, &_inner_error0_);
#line 181 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 503 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 180 "../src/Indicator.vala"
		e = _inner_error0_;
#line 180 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 183 "../src/Indicator.vala"
		_tmp8_ = e;
#line 183 "../src/Indicator.vala"
		_tmp9_ = _tmp8_->message;
#line 183 "../src/Indicator.vala"
		g_critical ("Indicator.vala:183: Couldn't ungrab accelerators: %s", _tmp9_);
#line 180 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 525 "Indicator.c"
	}
	__finally0:
#line 180 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 180 "../src/Indicator.vala"
		actions = (g_free (actions), NULL);
#line 180 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 180 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 180 "../src/Indicator.vala"
		return;
#line 538 "Indicator.c"
	}
#line 177 "../src/Indicator.vala"
	actions = (g_free (actions), NULL);
#line 542 "Indicator.c"
}

static void
_vala_array_add1 (Accelerator* * array,
                  gint* length,
                  gint* size,
                  const Accelerator* value)
{
#line 192 "../src/Indicator.vala"
	if ((*length) == (*size)) {
#line 192 "../src/Indicator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 192 "../src/Indicator.vala"
		*array = g_renew (Accelerator, *array, *size);
#line 557 "Indicator.c"
	}
#line 192 "../src/Indicator.vala"
	(*array)[(*length)++] = *value;
#line 561 "Indicator.c"
}

static void
_vala_array_add2 (Accelerator* * array,
                  gint* length,
                  gint* size,
                  const Accelerator* value)
{
#line 201 "../src/Indicator.vala"
	if ((*length) == (*size)) {
#line 201 "../src/Indicator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 201 "../src/Indicator.vala"
		*array = g_renew (Accelerator, *array, *size);
#line 576 "Indicator.c"
	}
#line 201 "../src/Indicator.vala"
	(*array)[(*length)++] = *value;
#line 580 "Indicator.c"
}

static void
_vala_array_add3 (Accelerator* * array,
                  gint* length,
                  gint* size,
                  const Accelerator* value)
{
#line 210 "../src/Indicator.vala"
	if ((*length) == (*size)) {
#line 210 "../src/Indicator.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 210 "../src/Indicator.vala"
		*array = g_renew (Accelerator, *array, *size);
#line 595 "Indicator.c"
	}
#line 210 "../src/Indicator.vala"
	(*array)[(*length)++] = *value;
#line 599 "Indicator.c"
}

static void
_vala_Accelerator_array_free (Accelerator * array,
                              gssize array_length)
{
#line 222 "../src/Indicator.vala"
	if (array != NULL) {
#line 608 "Indicator.c"
		gssize i;
#line 222 "../src/Indicator.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 222 "../src/Indicator.vala"
			accelerator_destroy (&array[i]);
#line 614 "Indicator.c"
		}
	}
#line 222 "../src/Indicator.vala"
	g_free (array);
#line 619 "Indicator.c"
}

static void
_sound_indicator_on_accelerator_activated_shell_key_grabber_accelerator_activated (ShellKeyGrabber* _sender,
                                                                                   guint action,
                                                                                   GHashTable* parameters_dict,
                                                                                   gpointer self)
{
#line 235 "../src/Indicator.vala"
	sound_indicator_on_accelerator_activated ((SoundIndicator*) self, action, parameters_dict);
#line 630 "Indicator.c"
}

static void
sound_indicator_setup_grabs (SoundIndicator* self)
{
	ShellKeyGrabber* _tmp0_;
	Accelerator* accelerators = NULL;
	Accelerator* _tmp1_;
	gint accelerators_length1;
	gint _accelerators_size_;
	gchar** volume_up_keybindings = NULL;
	GSettings* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint volume_up_keybindings_length1;
	gint _volume_up_keybindings_size_;
	gchar** volume_down_keybindings = NULL;
	GSettings* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint volume_down_keybindings_length1;
	gint _volume_down_keybindings_size_;
	gchar** volume_mute_keybindings = NULL;
	GSettings* _tmp22_;
	gchar** _tmp23_;
	gchar** _tmp24_;
	gint volume_mute_keybindings_length1;
	gint _volume_mute_keybindings_size_;
	guint* action_ids = NULL;
	gint action_ids_length1 = 0;
	gint _action_ids_size_ = 0;
	ShellKeyGrabber* _tmp55_;
	gulong _tmp56_;
	GError* _inner_error0_ = NULL;
#line 187 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/Indicator.vala"
	_tmp0_ = self->priv->key_grabber;
#line 187 "../src/Indicator.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "key_grabber != null");
#line 188 "../src/Indicator.vala"
	_tmp1_ = g_new0 (Accelerator, 0);
#line 188 "../src/Indicator.vala"
	accelerators = _tmp1_;
#line 188 "../src/Indicator.vala"
	accelerators_length1 = 0;
#line 188 "../src/Indicator.vala"
	_accelerators_size_ = accelerators_length1;
#line 190 "../src/Indicator.vala"
	_tmp2_ = sound_indicator_settings;
#line 190 "../src/Indicator.vala"
	_tmp4_ = _tmp3_ = g_settings_get_strv (_tmp2_, "volume-up");
#line 190 "../src/Indicator.vala"
	volume_up_keybindings = _tmp4_;
#line 190 "../src/Indicator.vala"
	volume_up_keybindings_length1 = _vala_array_length (_tmp3_);
#line 190 "../src/Indicator.vala"
	_volume_up_keybindings_size_ = volume_up_keybindings_length1;
#line 689 "Indicator.c"
	{
		gint i = 0;
#line 191 "../src/Indicator.vala"
		i = 0;
#line 694 "Indicator.c"
		{
			gboolean _tmp5_ = FALSE;
#line 191 "../src/Indicator.vala"
			_tmp5_ = TRUE;
#line 191 "../src/Indicator.vala"
			while (TRUE) {
#line 701 "Indicator.c"
				gchar** _tmp7_;
				gint _tmp7__length1;
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				Accelerator _tmp11_ = {0};
#line 191 "../src/Indicator.vala"
				if (!_tmp5_) {
#line 711 "Indicator.c"
					gint _tmp6_;
#line 191 "../src/Indicator.vala"
					_tmp6_ = i;
#line 191 "../src/Indicator.vala"
					i = _tmp6_ + 1;
#line 717 "Indicator.c"
				}
#line 191 "../src/Indicator.vala"
				_tmp5_ = FALSE;
#line 191 "../src/Indicator.vala"
				_tmp7_ = volume_up_keybindings;
#line 191 "../src/Indicator.vala"
				_tmp7__length1 = volume_up_keybindings_length1;
#line 191 "../src/Indicator.vala"
				if (!(i < _tmp7__length1)) {
#line 191 "../src/Indicator.vala"
					break;
#line 729 "Indicator.c"
				}
#line 192 "../src/Indicator.vala"
				_tmp8_ = volume_up_keybindings;
#line 192 "../src/Indicator.vala"
				_tmp8__length1 = volume_up_keybindings_length1;
#line 192 "../src/Indicator.vala"
				_tmp9_ = _tmp8_[i];
#line 192 "../src/Indicator.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 192 "../src/Indicator.vala"
				memset (&_tmp11_, 0, sizeof (Accelerator));
#line 192 "../src/Indicator.vala"
				_g_free0 (_tmp11_.name);
#line 192 "../src/Indicator.vala"
				_tmp11_.name = _tmp10_;
#line 192 "../src/Indicator.vala"
				_tmp11_.mode_flags = ACTION_MODE_NONE;
#line 192 "../src/Indicator.vala"
				_tmp11_.grab_flags = META_KEY_BINDING_FLAGS_NONE;
#line 192 "../src/Indicator.vala"
				_vala_array_add1 (&accelerators, &accelerators_length1, &_accelerators_size_, &_tmp11_);
#line 751 "Indicator.c"
			}
		}
	}
#line 199 "../src/Indicator.vala"
	_tmp12_ = sound_indicator_settings;
#line 199 "../src/Indicator.vala"
	_tmp14_ = _tmp13_ = g_settings_get_strv (_tmp12_, "volume-down");
#line 199 "../src/Indicator.vala"
	volume_down_keybindings = _tmp14_;
#line 199 "../src/Indicator.vala"
	volume_down_keybindings_length1 = _vala_array_length (_tmp13_);
#line 199 "../src/Indicator.vala"
	_volume_down_keybindings_size_ = volume_down_keybindings_length1;
#line 765 "Indicator.c"
	{
		gint i = 0;
#line 200 "../src/Indicator.vala"
		i = 0;
#line 770 "Indicator.c"
		{
			gboolean _tmp15_ = FALSE;
#line 200 "../src/Indicator.vala"
			_tmp15_ = TRUE;
#line 200 "../src/Indicator.vala"
			while (TRUE) {
#line 777 "Indicator.c"
				gchar** _tmp17_;
				gint _tmp17__length1;
				gchar** _tmp18_;
				gint _tmp18__length1;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				Accelerator _tmp21_ = {0};
#line 200 "../src/Indicator.vala"
				if (!_tmp15_) {
#line 787 "Indicator.c"
					gint _tmp16_;
#line 200 "../src/Indicator.vala"
					_tmp16_ = i;
#line 200 "../src/Indicator.vala"
					i = _tmp16_ + 1;
#line 793 "Indicator.c"
				}
#line 200 "../src/Indicator.vala"
				_tmp15_ = FALSE;
#line 200 "../src/Indicator.vala"
				_tmp17_ = volume_down_keybindings;
#line 200 "../src/Indicator.vala"
				_tmp17__length1 = volume_down_keybindings_length1;
#line 200 "../src/Indicator.vala"
				if (!(i < _tmp17__length1)) {
#line 200 "../src/Indicator.vala"
					break;
#line 805 "Indicator.c"
				}
#line 201 "../src/Indicator.vala"
				_tmp18_ = volume_down_keybindings;
#line 201 "../src/Indicator.vala"
				_tmp18__length1 = volume_down_keybindings_length1;
#line 201 "../src/Indicator.vala"
				_tmp19_ = _tmp18_[i];
#line 201 "../src/Indicator.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 201 "../src/Indicator.vala"
				memset (&_tmp21_, 0, sizeof (Accelerator));
#line 201 "../src/Indicator.vala"
				_g_free0 (_tmp21_.name);
#line 201 "../src/Indicator.vala"
				_tmp21_.name = _tmp20_;
#line 201 "../src/Indicator.vala"
				_tmp21_.mode_flags = ACTION_MODE_NONE;
#line 201 "../src/Indicator.vala"
				_tmp21_.grab_flags = META_KEY_BINDING_FLAGS_NONE;
#line 201 "../src/Indicator.vala"
				_vala_array_add2 (&accelerators, &accelerators_length1, &_accelerators_size_, &_tmp21_);
#line 827 "Indicator.c"
			}
		}
	}
#line 208 "../src/Indicator.vala"
	_tmp22_ = sound_indicator_settings;
#line 208 "../src/Indicator.vala"
	_tmp24_ = _tmp23_ = g_settings_get_strv (_tmp22_, "volume-mute");
#line 208 "../src/Indicator.vala"
	volume_mute_keybindings = _tmp24_;
#line 208 "../src/Indicator.vala"
	volume_mute_keybindings_length1 = _vala_array_length (_tmp23_);
#line 208 "../src/Indicator.vala"
	_volume_mute_keybindings_size_ = volume_mute_keybindings_length1;
#line 841 "Indicator.c"
	{
		gint i = 0;
#line 209 "../src/Indicator.vala"
		i = 0;
#line 846 "Indicator.c"
		{
			gboolean _tmp25_ = FALSE;
#line 209 "../src/Indicator.vala"
			_tmp25_ = TRUE;
#line 209 "../src/Indicator.vala"
			while (TRUE) {
#line 853 "Indicator.c"
				gchar** _tmp27_;
				gint _tmp27__length1;
				gchar** _tmp28_;
				gint _tmp28__length1;
				const gchar* _tmp29_;
				gchar* _tmp30_;
				Accelerator _tmp31_ = {0};
#line 209 "../src/Indicator.vala"
				if (!_tmp25_) {
#line 863 "Indicator.c"
					gint _tmp26_;
#line 209 "../src/Indicator.vala"
					_tmp26_ = i;
#line 209 "../src/Indicator.vala"
					i = _tmp26_ + 1;
#line 869 "Indicator.c"
				}
#line 209 "../src/Indicator.vala"
				_tmp25_ = FALSE;
#line 209 "../src/Indicator.vala"
				_tmp27_ = volume_mute_keybindings;
#line 209 "../src/Indicator.vala"
				_tmp27__length1 = volume_mute_keybindings_length1;
#line 209 "../src/Indicator.vala"
				if (!(i < _tmp27__length1)) {
#line 209 "../src/Indicator.vala"
					break;
#line 881 "Indicator.c"
				}
#line 210 "../src/Indicator.vala"
				_tmp28_ = volume_mute_keybindings;
#line 210 "../src/Indicator.vala"
				_tmp28__length1 = volume_mute_keybindings_length1;
#line 210 "../src/Indicator.vala"
				_tmp29_ = _tmp28_[i];
#line 210 "../src/Indicator.vala"
				_tmp30_ = g_strdup (_tmp29_);
#line 210 "../src/Indicator.vala"
				memset (&_tmp31_, 0, sizeof (Accelerator));
#line 210 "../src/Indicator.vala"
				_g_free0 (_tmp31_.name);
#line 210 "../src/Indicator.vala"
				_tmp31_.name = _tmp30_;
#line 210 "../src/Indicator.vala"
				_tmp31_.mode_flags = ACTION_MODE_NONE;
#line 210 "../src/Indicator.vala"
				_tmp31_.grab_flags = META_KEY_BINDING_FLAGS_IGNORE_AUTOREPEAT;
#line 210 "../src/Indicator.vala"
				_vala_array_add3 (&accelerators, &accelerators_length1, &_accelerators_size_, &_tmp31_);
#line 903 "Indicator.c"
			}
		}
	}
	{
		guint* _tmp32_ = NULL;
		ShellKeyGrabber* _tmp33_;
		Accelerator* _tmp34_;
		gint _tmp34__length1;
		gint _tmp35_ = 0;
		guint* _tmp36_;
		gint _tmp32__length1;
		gint __tmp32__size_;
		guint* _tmp37_;
		gint _tmp37__length1;
#line 219 "../src/Indicator.vala"
		_tmp33_ = self->priv->key_grabber;
#line 219 "../src/Indicator.vala"
		_tmp34_ = accelerators;
#line 219 "../src/Indicator.vala"
		_tmp34__length1 = accelerators_length1;
#line 219 "../src/Indicator.vala"
		_tmp36_ = shell_key_grabber_grab_accelerators (_tmp33_, _tmp34_, (gint) _tmp34__length1, &_tmp35_, &_inner_error0_);
#line 219 "../src/Indicator.vala"
		_tmp32_ = _tmp36_;
#line 219 "../src/Indicator.vala"
		_tmp32__length1 = _tmp35_;
#line 219 "../src/Indicator.vala"
		__tmp32__size_ = _tmp32__length1;
#line 219 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 934 "Indicator.c"
			goto __catch0_g_error;
		}
#line 219 "../src/Indicator.vala"
		_tmp37_ = _tmp32_;
#line 219 "../src/Indicator.vala"
		_tmp37__length1 = _tmp32__length1;
#line 219 "../src/Indicator.vala"
		_tmp32_ = NULL;
#line 219 "../src/Indicator.vala"
		_tmp32__length1 = 0;
#line 219 "../src/Indicator.vala"
		action_ids = (g_free (action_ids), NULL);
#line 219 "../src/Indicator.vala"
		action_ids = _tmp37_;
#line 219 "../src/Indicator.vala"
		action_ids_length1 = _tmp37__length1;
#line 219 "../src/Indicator.vala"
		_action_ids_size_ = action_ids_length1;
#line 218 "../src/Indicator.vala"
		_tmp32_ = (g_free (_tmp32_), NULL);
#line 955 "Indicator.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp38_;
		const gchar* _tmp39_;
#line 218 "../src/Indicator.vala"
		e = _inner_error0_;
#line 218 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 221 "../src/Indicator.vala"
		_tmp38_ = e;
#line 221 "../src/Indicator.vala"
		_tmp39_ = _tmp38_->message;
#line 221 "../src/Indicator.vala"
		g_critical ("Indicator.vala:221: %s", _tmp39_);
#line 222 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 222 "../src/Indicator.vala"
		action_ids = (g_free (action_ids), NULL);
#line 222 "../src/Indicator.vala"
		volume_mute_keybindings = (_vala_array_free (volume_mute_keybindings, volume_mute_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 222 "../src/Indicator.vala"
		volume_down_keybindings = (_vala_array_free (volume_down_keybindings, volume_down_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 222 "../src/Indicator.vala"
		volume_up_keybindings = (_vala_array_free (volume_up_keybindings, volume_up_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 222 "../src/Indicator.vala"
		accelerators = (_vala_Accelerator_array_free (accelerators, accelerators_length1), NULL);
#line 222 "../src/Indicator.vala"
		return;
#line 987 "Indicator.c"
	}
	__finally0:
#line 218 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "../src/Indicator.vala"
		action_ids = (g_free (action_ids), NULL);
#line 218 "../src/Indicator.vala"
		volume_mute_keybindings = (_vala_array_free (volume_mute_keybindings, volume_mute_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 218 "../src/Indicator.vala"
		volume_down_keybindings = (_vala_array_free (volume_down_keybindings, volume_down_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 218 "../src/Indicator.vala"
		volume_up_keybindings = (_vala_array_free (volume_up_keybindings, volume_up_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 218 "../src/Indicator.vala"
		accelerators = (_vala_Accelerator_array_free (accelerators, accelerators_length1), NULL);
#line 218 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 218 "../src/Indicator.vala"
		return;
#line 1008 "Indicator.c"
	}
	{
		gint i = 0;
#line 225 "../src/Indicator.vala"
		i = 0;
#line 1014 "Indicator.c"
		{
			gboolean _tmp40_ = FALSE;
#line 225 "../src/Indicator.vala"
			_tmp40_ = TRUE;
#line 225 "../src/Indicator.vala"
			while (TRUE) {
#line 1021 "Indicator.c"
				guint* _tmp42_;
				gint _tmp42__length1;
				gchar** _tmp43_;
				gint _tmp43__length1;
#line 225 "../src/Indicator.vala"
				if (!_tmp40_) {
#line 1028 "Indicator.c"
					gint _tmp41_;
#line 225 "../src/Indicator.vala"
					_tmp41_ = i;
#line 225 "../src/Indicator.vala"
					i = _tmp41_ + 1;
#line 1034 "Indicator.c"
				}
#line 225 "../src/Indicator.vala"
				_tmp40_ = FALSE;
#line 225 "../src/Indicator.vala"
				_tmp42_ = action_ids;
#line 225 "../src/Indicator.vala"
				_tmp42__length1 = action_ids_length1;
#line 225 "../src/Indicator.vala"
				if (!(i < _tmp42__length1)) {
#line 225 "../src/Indicator.vala"
					break;
#line 1046 "Indicator.c"
				}
#line 226 "../src/Indicator.vala"
				_tmp43_ = volume_up_keybindings;
#line 226 "../src/Indicator.vala"
				_tmp43__length1 = volume_up_keybindings_length1;
#line 226 "../src/Indicator.vala"
				if (i < _tmp43__length1) {
#line 1054 "Indicator.c"
					GeeHashMultiMap* _tmp44_;
					guint* _tmp45_;
					gint _tmp45__length1;
					guint _tmp46_;
#line 227 "../src/Indicator.vala"
					_tmp44_ = self->priv->saved_action_ids;
#line 227 "../src/Indicator.vala"
					_tmp45_ = action_ids;
#line 227 "../src/Indicator.vala"
					_tmp45__length1 = action_ids_length1;
#line 227 "../src/Indicator.vala"
					_tmp46_ = _tmp45_[i];
#line 227 "../src/Indicator.vala"
					gee_multi_map_set ((GeeMultiMap*) _tmp44_, "volume-up", (gpointer) ((guintptr) _tmp46_));
#line 1069 "Indicator.c"
				} else {
					gchar** _tmp47_;
					gint _tmp47__length1;
					gchar** _tmp48_;
					gint _tmp48__length1;
#line 228 "../src/Indicator.vala"
					_tmp47_ = volume_up_keybindings;
#line 228 "../src/Indicator.vala"
					_tmp47__length1 = volume_up_keybindings_length1;
#line 228 "../src/Indicator.vala"
					_tmp48_ = volume_down_keybindings;
#line 228 "../src/Indicator.vala"
					_tmp48__length1 = volume_down_keybindings_length1;
#line 228 "../src/Indicator.vala"
					if (i < (_tmp47__length1 + _tmp48__length1)) {
#line 1085 "Indicator.c"
						GeeHashMultiMap* _tmp49_;
						guint* _tmp50_;
						gint _tmp50__length1;
						guint _tmp51_;
#line 229 "../src/Indicator.vala"
						_tmp49_ = self->priv->saved_action_ids;
#line 229 "../src/Indicator.vala"
						_tmp50_ = action_ids;
#line 229 "../src/Indicator.vala"
						_tmp50__length1 = action_ids_length1;
#line 229 "../src/Indicator.vala"
						_tmp51_ = _tmp50_[i];
#line 229 "../src/Indicator.vala"
						gee_multi_map_set ((GeeMultiMap*) _tmp49_, "volume-down", (gpointer) ((guintptr) _tmp51_));
#line 1100 "Indicator.c"
					} else {
						GeeHashMultiMap* _tmp52_;
						guint* _tmp53_;
						gint _tmp53__length1;
						guint _tmp54_;
#line 231 "../src/Indicator.vala"
						_tmp52_ = self->priv->saved_action_ids;
#line 231 "../src/Indicator.vala"
						_tmp53_ = action_ids;
#line 231 "../src/Indicator.vala"
						_tmp53__length1 = action_ids_length1;
#line 231 "../src/Indicator.vala"
						_tmp54_ = _tmp53_[i];
#line 231 "../src/Indicator.vala"
						gee_multi_map_set ((GeeMultiMap*) _tmp52_, "volume-mute", (gpointer) ((guintptr) _tmp54_));
#line 1116 "Indicator.c"
					}
				}
			}
		}
	}
#line 235 "../src/Indicator.vala"
	_tmp55_ = self->priv->key_grabber;
#line 235 "../src/Indicator.vala"
	_tmp56_ = g_signal_connect_object (_tmp55_, "accelerator-activated", (GCallback) _sound_indicator_on_accelerator_activated_shell_key_grabber_accelerator_activated, self, 0);
#line 235 "../src/Indicator.vala"
	self->priv->key_grabber_id = _tmp56_;
#line 187 "../src/Indicator.vala"
	action_ids = (g_free (action_ids), NULL);
#line 187 "../src/Indicator.vala"
	volume_mute_keybindings = (_vala_array_free (volume_mute_keybindings, volume_mute_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 187 "../src/Indicator.vala"
	volume_down_keybindings = (_vala_array_free (volume_down_keybindings, volume_down_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 187 "../src/Indicator.vala"
	volume_up_keybindings = (_vala_array_free (volume_up_keybindings, volume_up_keybindings_length1, (GDestroyNotify) g_free), NULL);
#line 187 "../src/Indicator.vala"
	accelerators = (_vala_Accelerator_array_free (accelerators, accelerators_length1), NULL);
#line 1138 "Indicator.c"
}

static void
sound_indicator_on_accelerator_activated (SoundIndicator* self,
                                          guint action,
                                          GHashTable* parameters_dict)
{
	GeeHashMultiMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	gboolean _tmp3_;
#line 238 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/Indicator.vala"
	g_return_if_fail (parameters_dict != NULL);
#line 239 "../src/Indicator.vala"
	_tmp0_ = self->priv->saved_action_ids;
#line 239 "../src/Indicator.vala"
	_tmp1_ = gee_multi_map_get ((GeeMultiMap*) _tmp0_, "volume-up");
#line 239 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 239 "../src/Indicator.vala"
	_tmp3_ = gee_collection_contains (_tmp2_, (gpointer) ((guintptr) action));
#line 239 "../src/Indicator.vala"
	_g_object_unref0 (_tmp2_);
#line 239 "../src/Indicator.vala"
	if (_tmp3_) {
#line 240 "../src/Indicator.vala"
		sound_indicator_handle_change (self, 1.0, FALSE);
#line 1168 "Indicator.c"
	} else {
		GeeHashMultiMap* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		gboolean _tmp7_;
#line 241 "../src/Indicator.vala"
		_tmp4_ = self->priv->saved_action_ids;
#line 241 "../src/Indicator.vala"
		_tmp5_ = gee_multi_map_get ((GeeMultiMap*) _tmp4_, "volume-down");
#line 241 "../src/Indicator.vala"
		_tmp6_ = _tmp5_;
#line 241 "../src/Indicator.vala"
		_tmp7_ = gee_collection_contains (_tmp6_, (gpointer) ((guintptr) action));
#line 241 "../src/Indicator.vala"
		_g_object_unref0 (_tmp6_);
#line 241 "../src/Indicator.vala"
		if (_tmp7_) {
#line 242 "../src/Indicator.vala"
			sound_indicator_handle_change (self, -1.0, FALSE);
#line 1188 "Indicator.c"
		} else {
			GeeHashMultiMap* _tmp8_;
			GeeCollection* _tmp9_;
			GeeCollection* _tmp10_;
			gboolean _tmp11_;
#line 243 "../src/Indicator.vala"
			_tmp8_ = self->priv->saved_action_ids;
#line 243 "../src/Indicator.vala"
			_tmp9_ = gee_multi_map_get ((GeeMultiMap*) _tmp8_, "volume-mute");
#line 243 "../src/Indicator.vala"
			_tmp10_ = _tmp9_;
#line 243 "../src/Indicator.vala"
			_tmp11_ = gee_collection_contains (_tmp10_, (gpointer) ((guintptr) action));
#line 243 "../src/Indicator.vala"
			_g_object_unref0 (_tmp10_);
#line 243 "../src/Indicator.vala"
			if (_tmp11_) {
#line 1206 "Indicator.c"
				SoundServicesVolumeControlPulse* _tmp12_;
#line 244 "../src/Indicator.vala"
				_tmp12_ = self->priv->volume_control;
#line 244 "../src/Indicator.vala"
				sound_services_volume_control_pulse_toggle_mute (_tmp12_);
#line 245 "../src/Indicator.vala"
				sound_indicator_notify_change (self, FALSE);
#line 1214 "Indicator.c"
			}
		}
	}
}

static void
sound_indicator_set_max_volume (SoundIndicator* self)
{
	gdouble max = 0.0;
	GSettings* _tmp0_;
	gdouble cap_volume = 0.0;
#line 259 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 260 "../src/Indicator.vala"
	_tmp0_ = sound_indicator_settings;
#line 260 "../src/Indicator.vala"
	max = g_settings_get_double (_tmp0_, "max-volume") / 100;
#line 262 "../src/Indicator.vala"
	cap_volume = ((gdouble) pa_sw_volume_from_dB (11.0)) / PA_VOLUME_NORM;
#line 263 "../src/Indicator.vala"
	if (max > cap_volume) {
#line 264 "../src/Indicator.vala"
		max = cap_volume;
#line 1238 "Indicator.c"
	}
#line 267 "../src/Indicator.vala"
	self->priv->max_volume = max;
#line 268 "../src/Indicator.vala"
	sound_indicator_on_volume_change (self);
#line 1244 "Indicator.c"
}

static void
sound_indicator_on_volume_change (SoundIndicator* self)
{
	gdouble volume = 0.0;
	SoundServicesVolumeControlPulse* _tmp0_;
	SoundServicesVolumeControlVolume* _tmp1_;
	SoundServicesVolumeControlVolume* _tmp2_;
	SoundWidgetsScale* _tmp3_;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
#line 271 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 272 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp0_);
#line 272 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 272 "../src/Indicator.vala"
	volume = _tmp2_->volume / self->priv->max_volume;
#line 273 "../src/Indicator.vala"
	_tmp3_ = self->priv->volume_scale;
#line 273 "../src/Indicator.vala"
	_tmp4_ = sound_widgets_scale_get_scale_widget (_tmp3_);
#line 273 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 273 "../src/Indicator.vala"
	if (volume != gtk_range_get_value ((GtkRange*) _tmp5_)) {
#line 1275 "Indicator.c"
		SoundWidgetsScale* _tmp6_;
		GtkScale* _tmp7_;
		GtkScale* _tmp8_;
		DisplayWidget* _tmp9_;
		const gchar* _tmp10_;
#line 274 "../src/Indicator.vala"
		_tmp6_ = self->priv->volume_scale;
#line 274 "../src/Indicator.vala"
		_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
#line 274 "../src/Indicator.vala"
		_tmp8_ = _tmp7_;
#line 274 "../src/Indicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp8_, volume);
#line 275 "../src/Indicator.vala"
		_tmp9_ = self->priv->display_widget;
#line 275 "../src/Indicator.vala"
		_tmp10_ = sound_indicator_get_volume_icon (self, volume);
#line 275 "../src/Indicator.vala"
		display_widget_set_icon_name (_tmp9_, _tmp10_);
#line 1295 "Indicator.c"
	}
}

static void
sound_indicator_on_mic_volume_change (SoundIndicator* self)
{
	gdouble volume = 0.0;
	SoundServicesVolumeControlPulse* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	SoundWidgetsScale* _tmp3_;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
#line 279 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 280 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 280 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp0_);
#line 280 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 280 "../src/Indicator.vala"
	volume = _tmp2_;
#line 282 "../src/Indicator.vala"
	_tmp3_ = self->priv->mic_scale;
#line 282 "../src/Indicator.vala"
	_tmp4_ = sound_widgets_scale_get_scale_widget (_tmp3_);
#line 282 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 282 "../src/Indicator.vala"
	if (volume != gtk_range_get_value ((GtkRange*) _tmp5_)) {
#line 1327 "Indicator.c"
		SoundWidgetsScale* _tmp6_;
		GtkScale* _tmp7_;
		GtkScale* _tmp8_;
#line 283 "../src/Indicator.vala"
		_tmp6_ = self->priv->mic_scale;
#line 283 "../src/Indicator.vala"
		_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
#line 283 "../src/Indicator.vala"
		_tmp8_ = _tmp7_;
#line 283 "../src/Indicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp8_, volume);
#line 1339 "Indicator.c"
	}
}

static void
sound_indicator_on_mute_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* volume_icon = NULL;
	SoundServicesVolumeControlPulse* _tmp4_;
	SoundServicesVolumeControlVolume* _tmp5_;
	SoundServicesVolumeControlVolume* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	DisplayWidget* _tmp9_;
	const gchar* _tmp10_;
	SoundServicesVolumeControlPulse* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
#line 287 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 288 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_scale;
#line 288 "../src/Indicator.vala"
	_tmp1_ = self->priv->volume_control;
#line 288 "../src/Indicator.vala"
	_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
#line 288 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 288 "../src/Indicator.vala"
	sound_widgets_scale_set_active (_tmp0_, !_tmp3_);
#line 290 "../src/Indicator.vala"
	_tmp4_ = self->priv->volume_control;
#line 290 "../src/Indicator.vala"
	_tmp5_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp4_);
#line 290 "../src/Indicator.vala"
	_tmp6_ = _tmp5_;
#line 290 "../src/Indicator.vala"
	_tmp7_ = sound_indicator_get_volume_icon (self, _tmp6_->volume);
#line 290 "../src/Indicator.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 290 "../src/Indicator.vala"
	volume_icon = _tmp8_;
#line 291 "../src/Indicator.vala"
	_tmp9_ = self->priv->display_widget;
#line 291 "../src/Indicator.vala"
	_tmp10_ = volume_icon;
#line 291 "../src/Indicator.vala"
	display_widget_set_icon_name (_tmp9_, _tmp10_);
#line 293 "../src/Indicator.vala"
	_tmp11_ = self->priv->volume_control;
#line 293 "../src/Indicator.vala"
	_tmp12_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp11_);
#line 293 "../src/Indicator.vala"
	_tmp13_ = _tmp12_;
#line 293 "../src/Indicator.vala"
	if (_tmp13_) {
#line 1399 "Indicator.c"
		SoundWidgetsScale* _tmp14_;
#line 294 "../src/Indicator.vala"
		_tmp14_ = self->priv->volume_scale;
#line 294 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp14_, "audio-volume-muted-symbolic");
#line 1405 "Indicator.c"
	} else {
		SoundWidgetsScale* _tmp15_;
		const gchar* _tmp16_;
#line 296 "../src/Indicator.vala"
		_tmp15_ = self->priv->volume_scale;
#line 296 "../src/Indicator.vala"
		_tmp16_ = volume_icon;
#line 296 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp15_, _tmp16_);
#line 1415 "Indicator.c"
	}
#line 287 "../src/Indicator.vala"
	_g_free0 (volume_icon);
#line 1419 "Indicator.c"
}

static void
sound_indicator_on_mic_mute_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	DisplayWidget* _tmp4_;
	SoundServicesVolumeControlPulse* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundServicesVolumeControlPulse* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 300 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/Indicator.vala"
	_tmp0_ = self->priv->mic_scale;
#line 301 "../src/Indicator.vala"
	_tmp1_ = self->priv->volume_control;
#line 301 "../src/Indicator.vala"
	_tmp2_ = sound_services_volume_control_pulse_get_micMute (_tmp1_);
#line 301 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 301 "../src/Indicator.vala"
	sound_widgets_scale_set_active (_tmp0_, !_tmp3_);
#line 302 "../src/Indicator.vala"
	_tmp4_ = self->priv->display_widget;
#line 302 "../src/Indicator.vala"
	_tmp5_ = self->priv->volume_control;
#line 302 "../src/Indicator.vala"
	_tmp6_ = sound_services_volume_control_pulse_get_micMute (_tmp5_);
#line 302 "../src/Indicator.vala"
	_tmp7_ = _tmp6_;
#line 302 "../src/Indicator.vala"
	display_widget_set_mic_muted (_tmp4_, _tmp7_);
#line 304 "../src/Indicator.vala"
	_tmp8_ = self->priv->volume_control;
#line 304 "../src/Indicator.vala"
	_tmp9_ = sound_services_volume_control_pulse_get_micMute (_tmp8_);
#line 304 "../src/Indicator.vala"
	_tmp10_ = _tmp9_;
#line 304 "../src/Indicator.vala"
	if (_tmp10_) {
#line 1466 "Indicator.c"
		SoundWidgetsScale* _tmp11_;
#line 305 "../src/Indicator.vala"
		_tmp11_ = self->priv->mic_scale;
#line 305 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp11_, "indicator-microphone-muted-symbolic");
#line 1472 "Indicator.c"
	} else {
		SoundWidgetsScale* _tmp12_;
#line 307 "../src/Indicator.vala"
		_tmp12_ = self->priv->mic_scale;
#line 307 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp12_, "indicator-microphone-symbolic");
#line 1479 "Indicator.c"
	}
}

static gboolean
____lambda58_ (SoundIndicator* self)
{
	DisplayWidget* _tmp0_;
	SoundServicesVolumeControlPulse* _tmp1_;
	SoundServicesVolumeControlVolume* _tmp2_;
	SoundServicesVolumeControlVolume* _tmp3_;
	const gchar* _tmp4_;
	gboolean result;
#line 325 "../src/Indicator.vala"
	self->priv->mute_blocks_sound = FALSE;
#line 326 "../src/Indicator.vala"
	self->priv->sound_was_blocked_timeout_id = (guint) 0;
#line 327 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_widget;
#line 327 "../src/Indicator.vala"
	_tmp1_ = self->priv->volume_control;
#line 327 "../src/Indicator.vala"
	_tmp2_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp1_);
#line 327 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 327 "../src/Indicator.vala"
	_tmp4_ = sound_indicator_get_volume_icon (self, _tmp3_->volume);
#line 327 "../src/Indicator.vala"
	display_widget_set_icon_name (_tmp0_, _tmp4_);
#line 328 "../src/Indicator.vala"
	result = FALSE;
#line 328 "../src/Indicator.vala"
	return result;
#line 1512 "Indicator.c"
}

static gboolean
_____lambda58__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda58_ ((SoundIndicator*) self);
#line 324 "../src/Indicator.vala"
	return result;
#line 1522 "Indicator.c"
}

static void
sound_indicator_on_is_playing_change (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SoundServicesVolumeControlPulse* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	DisplayWidget* _tmp6_;
	SoundServicesVolumeControlPulse* _tmp7_;
	SoundServicesVolumeControlVolume* _tmp8_;
	SoundServicesVolumeControlVolume* _tmp9_;
	const gchar* _tmp10_;
#line 311 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 312 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 312 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp0_);
#line 312 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 312 "../src/Indicator.vala"
	if (!_tmp2_) {
#line 313 "../src/Indicator.vala"
		self->priv->mute_blocks_sound = FALSE;
#line 314 "../src/Indicator.vala"
		return;
#line 1553 "Indicator.c"
	}
#line 316 "../src/Indicator.vala"
	_tmp3_ = self->priv->volume_control;
#line 316 "../src/Indicator.vala"
	_tmp4_ = sound_services_volume_control_get_is_playing ((SoundServicesVolumeControl*) _tmp3_);
#line 316 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 316 "../src/Indicator.vala"
	if (_tmp5_) {
#line 317 "../src/Indicator.vala"
		self->priv->mute_blocks_sound = TRUE;
#line 1565 "Indicator.c"
	} else {
#line 318 "../src/Indicator.vala"
		if (self->priv->mute_blocks_sound) {
#line 320 "../src/Indicator.vala"
			if (self->priv->sound_was_blocked_timeout_id > ((guint) 0)) {
#line 321 "../src/Indicator.vala"
				g_source_remove (self->priv->sound_was_blocked_timeout_id);
#line 1573 "Indicator.c"
			}
#line 324 "../src/Indicator.vala"
			self->priv->sound_was_blocked_timeout_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, _____lambda58__gsource_func, g_object_ref (self), g_object_unref);
#line 1577 "Indicator.c"
		}
	}
#line 332 "../src/Indicator.vala"
	_tmp6_ = self->priv->display_widget;
#line 332 "../src/Indicator.vala"
	_tmp7_ = self->priv->volume_control;
#line 332 "../src/Indicator.vala"
	_tmp8_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp7_);
#line 332 "../src/Indicator.vala"
	_tmp9_ = _tmp8_;
#line 332 "../src/Indicator.vala"
	_tmp10_ = sound_indicator_get_volume_icon (self, _tmp9_->volume);
#line 332 "../src/Indicator.vala"
	display_widget_set_icon_name (_tmp6_, _tmp10_);
#line 1592 "Indicator.c"
}

static void
sound_indicator_on_volume_icon_scroll_event (SoundIndicator* self,
                                             GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
#line 335 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 335 "../src/Indicator.vala"
	g_return_if_fail (e != NULL);
#line 336 "../src/Indicator.vala"
	dir = 0.0;
#line 337 "../src/Indicator.vala"
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
#line 337 "../src/Indicator.vala"
	dir = _tmp0_;
#line 337 "../src/Indicator.vala"
	if (_tmp1_) {
#line 338 "../src/Indicator.vala"
		sound_indicator_handle_change (self, dir, FALSE);
#line 1616 "Indicator.c"
	}
}

static void
sound_indicator_on_mic_icon_scroll_event (SoundIndicator* self,
                                          GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
#line 342 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 342 "../src/Indicator.vala"
	g_return_if_fail (e != NULL);
#line 343 "../src/Indicator.vala"
	dir = 0.0;
#line 344 "../src/Indicator.vala"
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
#line 344 "../src/Indicator.vala"
	dir = _tmp0_;
#line 344 "../src/Indicator.vala"
	if (_tmp1_) {
#line 345 "../src/Indicator.vala"
		sound_indicator_handle_change (self, dir, TRUE);
#line 1641 "Indicator.c"
	}
}

static void
sound_indicator_update_mic_visibility (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 349 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 350 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 350 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_is_listening ((SoundServicesVolumeControl*) _tmp0_);
#line 350 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 350 "../src/Indicator.vala"
	if (_tmp2_) {
#line 1661 "Indicator.c"
		SoundWidgetsScale* _tmp3_;
		SoundWidgetsScale* _tmp4_;
		GtkSeparator* _tmp5_;
		GtkSeparator* _tmp6_;
		SoundWidgetsDeviceManagerWidget* _tmp7_;
		SoundWidgetsDeviceManagerWidget* _tmp8_;
		DisplayWidget* _tmp9_;
#line 351 "../src/Indicator.vala"
		_tmp3_ = self->priv->mic_scale;
#line 351 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp3_, FALSE);
#line 352 "../src/Indicator.vala"
		_tmp4_ = self->priv->mic_scale;
#line 352 "../src/Indicator.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp4_);
#line 353 "../src/Indicator.vala"
		_tmp5_ = self->priv->mic_separator;
#line 353 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp5_, FALSE);
#line 354 "../src/Indicator.vala"
		_tmp6_ = self->priv->mic_separator;
#line 354 "../src/Indicator.vala"
		gtk_widget_show ((GtkWidget*) _tmp6_);
#line 355 "../src/Indicator.vala"
		_tmp7_ = self->priv->input_device_manager;
#line 355 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp7_, FALSE);
#line 356 "../src/Indicator.vala"
		_tmp8_ = self->priv->input_device_manager;
#line 356 "../src/Indicator.vala"
		gtk_widget_show ((GtkWidget*) _tmp8_);
#line 357 "../src/Indicator.vala"
		_tmp9_ = self->priv->display_widget;
#line 357 "../src/Indicator.vala"
		display_widget_set_show_mic (_tmp9_, TRUE);
#line 1697 "Indicator.c"
	} else {
		SoundWidgetsScale* _tmp10_;
		SoundWidgetsScale* _tmp11_;
		GtkSeparator* _tmp12_;
		GtkSeparator* _tmp13_;
		SoundWidgetsDeviceManagerWidget* _tmp14_;
		SoundWidgetsDeviceManagerWidget* _tmp15_;
		DisplayWidget* _tmp16_;
#line 359 "../src/Indicator.vala"
		_tmp10_ = self->priv->mic_scale;
#line 359 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp10_, TRUE);
#line 360 "../src/Indicator.vala"
		_tmp11_ = self->priv->mic_scale;
#line 360 "../src/Indicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp11_);
#line 361 "../src/Indicator.vala"
		_tmp12_ = self->priv->mic_separator;
#line 361 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp12_, TRUE);
#line 362 "../src/Indicator.vala"
		_tmp13_ = self->priv->mic_separator;
#line 362 "../src/Indicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp13_);
#line 363 "../src/Indicator.vala"
		_tmp14_ = self->priv->input_device_manager;
#line 363 "../src/Indicator.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp14_, TRUE);
#line 364 "../src/Indicator.vala"
		_tmp15_ = self->priv->input_device_manager;
#line 364 "../src/Indicator.vala"
		gtk_widget_hide ((GtkWidget*) _tmp15_);
#line 365 "../src/Indicator.vala"
		_tmp16_ = self->priv->display_widget;
#line 365 "../src/Indicator.vala"
		display_widget_set_show_mic (_tmp16_, FALSE);
#line 1734 "Indicator.c"
	}
}

static const gchar*
sound_indicator_get_volume_icon (SoundIndicator* self,
                                 gdouble volume)
{
	gboolean _tmp0_ = FALSE;
	const gchar* result;
#line 369 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 370 "../src/Indicator.vala"
	if (volume <= ((gdouble) 0)) {
#line 370 "../src/Indicator.vala"
		_tmp0_ = TRUE;
#line 1750 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 370 "../src/Indicator.vala"
		_tmp1_ = self->priv->volume_control;
#line 370 "../src/Indicator.vala"
		_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
#line 370 "../src/Indicator.vala"
		_tmp3_ = _tmp2_;
#line 370 "../src/Indicator.vala"
		_tmp0_ = _tmp3_;
#line 1763 "Indicator.c"
	}
#line 370 "../src/Indicator.vala"
	if (_tmp0_) {
#line 1767 "Indicator.c"
		const gchar* _tmp4_ = NULL;
#line 371 "../src/Indicator.vala"
		if (self->priv->mute_blocks_sound) {
#line 371 "../src/Indicator.vala"
			_tmp4_ = "audio-volume-muted-blocking-symbolic";
#line 1773 "Indicator.c"
		} else {
#line 371 "../src/Indicator.vala"
			_tmp4_ = "audio-volume-muted-symbolic";
#line 1777 "Indicator.c"
		}
#line 371 "../src/Indicator.vala"
		result = _tmp4_;
#line 371 "../src/Indicator.vala"
		return result;
#line 1783 "Indicator.c"
	} else {
#line 372 "../src/Indicator.vala"
		if (volume <= 0.3) {
#line 373 "../src/Indicator.vala"
			result = "audio-volume-low-symbolic";
#line 373 "../src/Indicator.vala"
			return result;
#line 1791 "Indicator.c"
		} else {
#line 374 "../src/Indicator.vala"
			if (volume <= 0.7) {
#line 375 "../src/Indicator.vala"
				result = "audio-volume-medium-symbolic";
#line 375 "../src/Indicator.vala"
				return result;
#line 1799 "Indicator.c"
			} else {
#line 377 "../src/Indicator.vala"
				result = "audio-volume-high-symbolic";
#line 377 "../src/Indicator.vala"
				return result;
#line 1805 "Indicator.c"
			}
		}
	}
}

static void
sound_indicator_on_volume_switch_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 381 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_scale;
#line 382 "../src/Indicator.vala"
	_tmp1_ = sound_widgets_scale_get_active (_tmp0_);
#line 382 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 382 "../src/Indicator.vala"
	if (_tmp2_) {
#line 1827 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp3_;
#line 383 "../src/Indicator.vala"
		_tmp3_ = self->priv->volume_control;
#line 383 "../src/Indicator.vala"
		sound_services_volume_control_set_mute ((SoundServicesVolumeControl*) _tmp3_, FALSE);
#line 1833 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
#line 385 "../src/Indicator.vala"
		_tmp4_ = self->priv->volume_control;
#line 385 "../src/Indicator.vala"
		sound_services_volume_control_set_mute ((SoundServicesVolumeControl*) _tmp4_, TRUE);
#line 1840 "Indicator.c"
	}
}

static void
sound_indicator_on_mic_switch_change (SoundIndicator* self)
{
	SoundWidgetsScale* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 389 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 390 "../src/Indicator.vala"
	_tmp0_ = self->priv->mic_scale;
#line 390 "../src/Indicator.vala"
	_tmp1_ = sound_widgets_scale_get_active (_tmp0_);
#line 390 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 390 "../src/Indicator.vala"
	if (_tmp2_) {
#line 1860 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp3_;
#line 391 "../src/Indicator.vala"
		_tmp3_ = self->priv->volume_control;
#line 391 "../src/Indicator.vala"
		sound_services_volume_control_pulse_set_mic_mute (_tmp3_, FALSE);
#line 1866 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
#line 393 "../src/Indicator.vala"
		_tmp4_ = self->priv->volume_control;
#line 393 "../src/Indicator.vala"
		sound_services_volume_control_pulse_set_mic_mute (_tmp4_, TRUE);
#line 1873 "Indicator.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 398 "../src/Indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 1882 "Indicator.c"
}

static GtkWidget*
sound_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	SoundIndicator * self;
	DisplayWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result;
#line 397 "../src/Indicator.vala"
	self = (SoundIndicator*) base;
#line 398 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_widget;
#line 398 "../src/Indicator.vala"
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
#line 398 "../src/Indicator.vala"
	result = _tmp1_;
#line 398 "../src/Indicator.vala"
	return result;
#line 1902 "Indicator.c"
}

static void
_sound_indicator_on_mic_switch_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 439 "../src/Indicator.vala"
	sound_indicator_on_mic_switch_change ((SoundIndicator*) self);
#line 1912 "Indicator.c"
}

static void
___lambda59_ (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	SoundWidgetsScale* _tmp1_;
	GtkScale* _tmp2_;
	GtkScale* _tmp3_;
#line 442 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 442 "../src/Indicator.vala"
	_tmp1_ = self->priv->mic_scale;
#line 442 "../src/Indicator.vala"
	_tmp2_ = sound_widgets_scale_get_scale_widget (_tmp1_);
#line 442 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 442 "../src/Indicator.vala"
	sound_services_volume_control_set_mic_volume ((SoundServicesVolumeControl*) _tmp0_, gtk_range_get_value ((GtkRange*) _tmp3_));
#line 1932 "Indicator.c"
}

static void
____lambda59__gtk_range_value_changed (GtkRange* _sender,
                                       gpointer self)
{
#line 441 "../src/Indicator.vala"
	___lambda59_ ((SoundIndicator*) self);
#line 1941 "Indicator.c"
}

static gboolean
___lambda60_ (SoundIndicator* self)
{
	gboolean result;
#line 446 "../src/Indicator.vala"
	sound_indicator_notify_change (self, TRUE);
#line 447 "../src/Indicator.vala"
	result = FALSE;
#line 447 "../src/Indicator.vala"
	return result;
#line 1954 "Indicator.c"
}

static gboolean
____lambda60__gtk_widget_button_release_event (GtkWidget* _sender,
                                               GdkEventButton* event,
                                               gpointer self)
{
	gboolean result;
	result = ___lambda60_ ((SoundIndicator*) self);
#line 445 "../src/Indicator.vala"
	return result;
#line 1966 "Indicator.c"
}

static gboolean
___lambda61_ (SoundIndicator* self,
              GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result;
#line 450 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 451 "../src/Indicator.vala"
	dir = 0.0;
#line 452 "../src/Indicator.vala"
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
#line 452 "../src/Indicator.vala"
	dir = _tmp0_;
#line 452 "../src/Indicator.vala"
	if (_tmp1_) {
#line 453 "../src/Indicator.vala"
		sound_indicator_handle_change (self, dir, TRUE);
#line 1989 "Indicator.c"
	}
#line 456 "../src/Indicator.vala"
	result = TRUE;
#line 456 "../src/Indicator.vala"
	return result;
#line 1995 "Indicator.c"
}

static gboolean
____lambda61__gtk_widget_scroll_event (GtkWidget* _sender,
                                       GdkEventScroll* event,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda61_ ((SoundIndicator*) self, event);
#line 450 "../src/Indicator.vala"
	return result;
#line 2007 "Indicator.c"
}

static void
___lambda62_ (SoundIndicator* self)
{
#line 460 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 2015 "Indicator.c"
}

static void
____lambda62__sound_widgets_player_list_close (SoundWidgetsPlayerList* _sender,
                                               gpointer self)
{
#line 459 "../src/Indicator.vala"
	___lambda62_ ((SoundIndicator*) self);
#line 2024 "Indicator.c"
}

static void
___lambda63_ (SoundIndicator* self)
{
#line 464 "../src/Indicator.vala"
	sound_indicator_show_settings (self);
#line 2032 "Indicator.c"
}

static void
____lambda63__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 463 "../src/Indicator.vala"
	___lambda63_ ((SoundIndicator*) self);
#line 2041 "Indicator.c"
}

static void
___lambda64_ (SoundIndicator* self)
{
	SoundServicesVolumeControlPulse* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 468 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_control;
#line 468 "../src/Indicator.vala"
	_tmp1_ = sound_services_volume_control_get_headphone_plugged ((SoundServicesVolumeControl*) _tmp0_);
#line 468 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 468 "../src/Indicator.vala"
	if (!_tmp2_) {
#line 2058 "Indicator.c"
		SoundWidgetsPlayerList* _tmp3_;
#line 469 "../src/Indicator.vala"
		_tmp3_ = self->priv->mpris;
#line 469 "../src/Indicator.vala"
		sound_widgets_player_list_pause_all (_tmp3_);
#line 2064 "Indicator.c"
	}
}

static void
____lambda64__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 467 "../src/Indicator.vala"
	___lambda64_ ((SoundIndicator*) self);
#line 2075 "Indicator.c"
}

static gboolean
___lambda65_ (SoundIndicator* self,
              GdkEventButton* e)
{
	gboolean result;
#line 473 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 474 "../src/Indicator.vala"
	sound_indicator_notify_change (self, FALSE);
#line 475 "../src/Indicator.vala"
	result = FALSE;
#line 475 "../src/Indicator.vala"
	return result;
#line 2091 "Indicator.c"
}

static gboolean
____lambda65__gtk_widget_button_release_event (GtkWidget* _sender,
                                               GdkEventButton* event,
                                               gpointer self)
{
	gboolean result;
	result = ___lambda65_ ((SoundIndicator*) self, event);
#line 473 "../src/Indicator.vala"
	return result;
#line 2103 "Indicator.c"
}

static gboolean
___lambda66_ (SoundIndicator* self,
              GdkEventScroll* e)
{
	gdouble dir = 0.0;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_;
	gboolean result;
#line 478 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 479 "../src/Indicator.vala"
	dir = 0.0;
#line 480 "../src/Indicator.vala"
	_tmp1_ = sound_indicator_handle_scroll_event (self, e, &_tmp0_);
#line 480 "../src/Indicator.vala"
	dir = _tmp0_;
#line 480 "../src/Indicator.vala"
	if (_tmp1_) {
#line 481 "../src/Indicator.vala"
		sound_indicator_handle_change (self, dir, FALSE);
#line 2126 "Indicator.c"
	}
#line 484 "../src/Indicator.vala"
	result = TRUE;
#line 484 "../src/Indicator.vala"
	return result;
#line 2132 "Indicator.c"
}

static gboolean
____lambda66__gtk_widget_scroll_event (GtkWidget* _sender,
                                       GdkEventScroll* event,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda66_ ((SoundIndicator*) self, event);
#line 478 "../src/Indicator.vala"
	return result;
#line 2144 "Indicator.c"
}

static void
_sound_indicator_on_volume_switch_change_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 487 "../src/Indicator.vala"
	sound_indicator_on_volume_switch_change ((SoundIndicator*) self);
#line 2154 "Indicator.c"
}

static void
___lambda67_ (SoundIndicator* self)
{
	gdouble val = 0.0;
	SoundWidgetsScale* _tmp0_;
	GtkScale* _tmp1_;
	GtkScale* _tmp2_;
	SoundServicesVolumeControlVolume* vol = NULL;
	SoundServicesVolumeControlVolume* _tmp3_ = NULL;
	SoundServicesVolumeControlPulse* _tmp4_;
	SoundWidgetsScale* _tmp5_;
	SoundWidgetsScale* _tmp6_;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	const gchar* _tmp9_;
#line 490 "../src/Indicator.vala"
	_tmp0_ = self->priv->volume_scale;
#line 490 "../src/Indicator.vala"
	_tmp1_ = sound_widgets_scale_get_scale_widget (_tmp0_);
#line 490 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 490 "../src/Indicator.vala"
	val = gtk_range_get_value ((GtkRange*) _tmp2_) * self->priv->max_volume;
#line 491 "../src/Indicator.vala"
	_tmp3_ = sound_services_volume_control_volume_new ();
#line 491 "../src/Indicator.vala"
	_tmp3_->volume = CLAMP (val, 0.0, self->priv->max_volume);
#line 491 "../src/Indicator.vala"
	_tmp3_->reason = SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS;
#line 491 "../src/Indicator.vala"
	vol = _tmp3_;
#line 495 "../src/Indicator.vala"
	_tmp4_ = self->priv->volume_control;
#line 495 "../src/Indicator.vala"
	sound_services_volume_control_set_volume ((SoundServicesVolumeControl*) _tmp4_, vol);
#line 496 "../src/Indicator.vala"
	_tmp5_ = self->priv->volume_scale;
#line 496 "../src/Indicator.vala"
	_tmp6_ = self->priv->volume_scale;
#line 496 "../src/Indicator.vala"
	_tmp7_ = sound_widgets_scale_get_scale_widget (_tmp6_);
#line 496 "../src/Indicator.vala"
	_tmp8_ = _tmp7_;
#line 496 "../src/Indicator.vala"
	_tmp9_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp8_));
#line 496 "../src/Indicator.vala"
	sound_widgets_scale_set_icon (_tmp5_, _tmp9_);
#line 489 "../src/Indicator.vala"
	_g_object_unref0 (vol);
#line 2206 "Indicator.c"
}

static void
____lambda67__gtk_range_value_changed (GtkRange* _sender,
                                       gpointer self)
{
#line 489 "../src/Indicator.vala"
	___lambda67_ ((SoundIndicator*) self);
#line 2215 "Indicator.c"
}

static GtkWidget*
sound_indicator_real_get_widget (WingpanelIndicator* base)
{
	SoundIndicator * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp72_;
	GtkWidget* _tmp73_;
	GtkWidget* result;
#line 402 "../src/Indicator.vala"
	self = (SoundIndicator*) base;
#line 403 "../src/Indicator.vala"
	_tmp0_ = self->priv->main_box;
#line 403 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 2232 "Indicator.c"
		SoundWidgetsPlayerList* _tmp1_;
		SoundWidgetsScale* _tmp2_;
		GtkSwitch* _tmp3_;
		GtkSwitch* _tmp4_;
		SoundServicesVolumeControlPulse* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		SoundWidgetsScale* _tmp8_;
		SoundServicesVolumeControlPulse* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
		SoundWidgetsScale* _tmp12_;
		GtkScale* _tmp13_;
		GtkScale* _tmp14_;
		SoundServicesVolumeControlPulse* _tmp15_;
		SoundServicesVolumeControlVolume* _tmp16_;
		SoundServicesVolumeControlVolume* _tmp17_;
		SoundWidgetsScale* _tmp18_;
		SoundWidgetsScale* _tmp19_;
		GtkScale* _tmp20_;
		GtkScale* _tmp21_;
		const gchar* _tmp22_;
		SoundWidgetsScale* _tmp23_;
		SoundServicesVolumeControlPulse* _tmp24_;
		gboolean _tmp25_;
		gboolean _tmp26_;
		GtkSeparator* _tmp27_;
		GtkModelButton* settings_button = NULL;
		gchar* _tmp28_;
		GtkModelButton* _tmp29_ = NULL;
		GtkBox* _tmp30_;
		gboolean _tmp31_;
		GtkBox* _tmp37_;
		SoundWidgetsScale* _tmp38_;
		GtkBox* _tmp39_;
		SoundWidgetsDeviceManagerWidget* _tmp40_;
		gboolean _tmp41_;
		SoundWidgetsScale* _tmp53_;
		SoundWidgetsScale* _tmp54_;
		GtkScale* _tmp55_;
		GtkScale* _tmp56_;
		SoundWidgetsScale* _tmp57_;
		GtkScale* _tmp58_;
		GtkScale* _tmp59_;
		SoundWidgetsScale* _tmp60_;
		SoundWidgetsPlayerList* _tmp61_;
		GtkModelButton* _tmp62_;
		SoundServicesVolumeControlPulse* _tmp63_;
		SoundWidgetsScale* _tmp64_;
		GtkScale* _tmp65_;
		GtkScale* _tmp66_;
		SoundWidgetsScale* _tmp67_;
		SoundWidgetsScale* _tmp68_;
		SoundWidgetsScale* _tmp69_;
		GtkScale* _tmp70_;
		GtkScale* _tmp71_;
#line 404 "../src/Indicator.vala"
		_tmp1_ = sound_widgets_player_list_new ();
#line 404 "../src/Indicator.vala"
		g_object_ref_sink (_tmp1_);
#line 404 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->mpris);
#line 404 "../src/Indicator.vala"
		self->priv->mpris = _tmp1_;
#line 406 "../src/Indicator.vala"
		_tmp2_ = self->priv->volume_scale;
#line 406 "../src/Indicator.vala"
		_tmp3_ = sound_widgets_scale_get_switch_widget (_tmp2_);
#line 406 "../src/Indicator.vala"
		_tmp4_ = _tmp3_;
#line 406 "../src/Indicator.vala"
		_tmp5_ = self->priv->volume_control;
#line 406 "../src/Indicator.vala"
		_tmp6_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp5_);
#line 406 "../src/Indicator.vala"
		_tmp7_ = _tmp6_;
#line 406 "../src/Indicator.vala"
		gtk_switch_set_active (_tmp4_, !_tmp7_);
#line 407 "../src/Indicator.vala"
		_tmp8_ = self->priv->volume_scale;
#line 407 "../src/Indicator.vala"
		_tmp9_ = self->priv->volume_control;
#line 407 "../src/Indicator.vala"
		_tmp10_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp9_);
#line 407 "../src/Indicator.vala"
		_tmp11_ = _tmp10_;
#line 407 "../src/Indicator.vala"
		sound_widgets_scale_set_active (_tmp8_, !_tmp11_);
#line 408 "../src/Indicator.vala"
		_tmp12_ = self->priv->volume_scale;
#line 408 "../src/Indicator.vala"
		_tmp13_ = sound_widgets_scale_get_scale_widget (_tmp12_);
#line 408 "../src/Indicator.vala"
		_tmp14_ = _tmp13_;
#line 408 "../src/Indicator.vala"
		_tmp15_ = self->priv->volume_control;
#line 408 "../src/Indicator.vala"
		_tmp16_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp15_);
#line 408 "../src/Indicator.vala"
		_tmp17_ = _tmp16_;
#line 408 "../src/Indicator.vala"
		gtk_range_set_value ((GtkRange*) _tmp14_, _tmp17_->volume);
#line 409 "../src/Indicator.vala"
		_tmp18_ = self->priv->volume_scale;
#line 409 "../src/Indicator.vala"
		_tmp19_ = self->priv->volume_scale;
#line 409 "../src/Indicator.vala"
		_tmp20_ = sound_widgets_scale_get_scale_widget (_tmp19_);
#line 409 "../src/Indicator.vala"
		_tmp21_ = _tmp20_;
#line 409 "../src/Indicator.vala"
		_tmp22_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp21_));
#line 409 "../src/Indicator.vala"
		sound_widgets_scale_set_icon (_tmp18_, _tmp22_);
#line 411 "../src/Indicator.vala"
		sound_indicator_set_max_volume (self);
#line 413 "../src/Indicator.vala"
		_tmp23_ = self->priv->mic_scale;
#line 413 "../src/Indicator.vala"
		_tmp24_ = self->priv->volume_control;
#line 413 "../src/Indicator.vala"
		_tmp25_ = sound_services_volume_control_pulse_get_micMute (_tmp24_);
#line 413 "../src/Indicator.vala"
		_tmp26_ = _tmp25_;
#line 413 "../src/Indicator.vala"
		sound_widgets_scale_set_active (_tmp23_, !_tmp26_);
#line 415 "../src/Indicator.vala"
		_tmp27_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 415 "../src/Indicator.vala"
		g_object_ref_sink (_tmp27_);
#line 415 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->mic_separator);
#line 415 "../src/Indicator.vala"
		self->priv->mic_separator = _tmp27_;
#line 417 "../src/Indicator.vala"
		sound_indicator_update_mic_visibility (self);
#line 419 "../src/Indicator.vala"
		_tmp28_ = g_strdup (_ ("Sound Settings…"));
#line 419 "../src/Indicator.vala"
		_tmp29_ = (GtkModelButton*) gtk_model_button_new ();
#line 419 "../src/Indicator.vala"
		g_object_set (_tmp29_, "text", _tmp28_, NULL);
#line 419 "../src/Indicator.vala"
		_g_free0 (_tmp28_);
#line 419 "../src/Indicator.vala"
		gtk_widget_set_margin_top ((GtkWidget*) _tmp29_, 3);
#line 419 "../src/Indicator.vala"
		g_object_ref_sink (_tmp29_);
#line 419 "../src/Indicator.vala"
		settings_button = _tmp29_;
#line 424 "../src/Indicator.vala"
		_tmp30_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 424 "../src/Indicator.vala"
		g_object_ref_sink (_tmp30_);
#line 424 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->main_box);
#line 424 "../src/Indicator.vala"
		self->priv->main_box = _tmp30_;
#line 425 "../src/Indicator.vala"
		_tmp31_ = self->priv->_is_in_session;
#line 425 "../src/Indicator.vala"
		if (_tmp31_) {
#line 2395 "Indicator.c"
			GtkBox* _tmp32_;
			SoundWidgetsPlayerList* _tmp33_;
			GtkBox* _tmp34_;
			GtkSeparator* _tmp35_;
			GtkSeparator* _tmp36_;
#line 426 "../src/Indicator.vala"
			_tmp32_ = self->priv->main_box;
#line 426 "../src/Indicator.vala"
			_tmp33_ = self->priv->mpris;
#line 426 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
#line 427 "../src/Indicator.vala"
			_tmp34_ = self->priv->main_box;
#line 427 "../src/Indicator.vala"
			_tmp35_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 427 "../src/Indicator.vala"
			g_object_ref_sink (_tmp35_);
#line 427 "../src/Indicator.vala"
			_tmp36_ = _tmp35_;
#line 427 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp36_);
#line 427 "../src/Indicator.vala"
			_g_object_unref0 (_tmp36_);
#line 2419 "Indicator.c"
		}
#line 429 "../src/Indicator.vala"
		_tmp37_ = self->priv->main_box;
#line 429 "../src/Indicator.vala"
		_tmp38_ = self->priv->volume_scale;
#line 429 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
#line 430 "../src/Indicator.vala"
		_tmp39_ = self->priv->main_box;
#line 430 "../src/Indicator.vala"
		_tmp40_ = self->priv->output_device_manager;
#line 430 "../src/Indicator.vala"
		gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
#line 431 "../src/Indicator.vala"
		_tmp41_ = self->priv->_is_in_session;
#line 431 "../src/Indicator.vala"
		if (_tmp41_) {
#line 2437 "Indicator.c"
			GtkBox* _tmp42_;
			GtkSeparator* _tmp43_;
			GtkSeparator* _tmp44_;
			GtkBox* _tmp45_;
			SoundWidgetsScale* _tmp46_;
			GtkBox* _tmp47_;
			SoundWidgetsDeviceManagerWidget* _tmp48_;
			GtkBox* _tmp49_;
			GtkSeparator* _tmp50_;
			GtkBox* _tmp51_;
			GtkModelButton* _tmp52_;
#line 432 "../src/Indicator.vala"
			_tmp42_ = self->priv->main_box;
#line 432 "../src/Indicator.vala"
			_tmp43_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 432 "../src/Indicator.vala"
			g_object_ref_sink (_tmp43_);
#line 432 "../src/Indicator.vala"
			_tmp44_ = _tmp43_;
#line 432 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp42_, (GtkWidget*) _tmp44_);
#line 432 "../src/Indicator.vala"
			_g_object_unref0 (_tmp44_);
#line 433 "../src/Indicator.vala"
			_tmp45_ = self->priv->main_box;
#line 433 "../src/Indicator.vala"
			_tmp46_ = self->priv->mic_scale;
#line 433 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp45_, (GtkWidget*) _tmp46_);
#line 434 "../src/Indicator.vala"
			_tmp47_ = self->priv->main_box;
#line 434 "../src/Indicator.vala"
			_tmp48_ = self->priv->input_device_manager;
#line 434 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 435 "../src/Indicator.vala"
			_tmp49_ = self->priv->main_box;
#line 435 "../src/Indicator.vala"
			_tmp50_ = self->priv->mic_separator;
#line 435 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp49_, (GtkWidget*) _tmp50_);
#line 436 "../src/Indicator.vala"
			_tmp51_ = self->priv->main_box;
#line 436 "../src/Indicator.vala"
			_tmp52_ = settings_button;
#line 436 "../src/Indicator.vala"
			gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
#line 2485 "Indicator.c"
		}
#line 439 "../src/Indicator.vala"
		_tmp53_ = self->priv->mic_scale;
#line 439 "../src/Indicator.vala"
		g_signal_connect_object ((GObject*) _tmp53_, "notify::active", (GCallback) _sound_indicator_on_mic_switch_change_g_object_notify, self, 0);
#line 441 "../src/Indicator.vala"
		_tmp54_ = self->priv->mic_scale;
#line 441 "../src/Indicator.vala"
		_tmp55_ = sound_widgets_scale_get_scale_widget (_tmp54_);
#line 441 "../src/Indicator.vala"
		_tmp56_ = _tmp55_;
#line 441 "../src/Indicator.vala"
		g_signal_connect_object ((GtkRange*) _tmp56_, "value-changed", (GCallback) ____lambda59__gtk_range_value_changed, self, 0);
#line 445 "../src/Indicator.vala"
		_tmp57_ = self->priv->mic_scale;
#line 445 "../src/Indicator.vala"
		_tmp58_ = sound_widgets_scale_get_scale_widget (_tmp57_);
#line 445 "../src/Indicator.vala"
		_tmp59_ = _tmp58_;
#line 445 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp59_, "button-release-event", (GCallback) ____lambda60__gtk_widget_button_release_event, self, 0);
#line 450 "../src/Indicator.vala"
		_tmp60_ = self->priv->mic_scale;
#line 450 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp60_, "scroll-event", (GCallback) ____lambda61__gtk_widget_scroll_event, self, G_CONNECT_AFTER);
#line 459 "../src/Indicator.vala"
		_tmp61_ = self->priv->mpris;
#line 459 "../src/Indicator.vala"
		g_signal_connect_object (_tmp61_, "close", (GCallback) ____lambda62__sound_widgets_player_list_close, self, 0);
#line 463 "../src/Indicator.vala"
		_tmp62_ = settings_button;
#line 463 "../src/Indicator.vala"
		g_signal_connect_object ((GtkButton*) _tmp62_, "clicked", (GCallback) ____lambda63__gtk_button_clicked, self, 0);
#line 467 "../src/Indicator.vala"
		_tmp63_ = self->priv->volume_control;
#line 467 "../src/Indicator.vala"
		g_signal_connect_object ((GObject*) _tmp63_, "notify::headphone-plugged", (GCallback) ____lambda64__g_object_notify, self, 0);
#line 473 "../src/Indicator.vala"
		_tmp64_ = self->priv->volume_scale;
#line 473 "../src/Indicator.vala"
		_tmp65_ = sound_widgets_scale_get_scale_widget (_tmp64_);
#line 473 "../src/Indicator.vala"
		_tmp66_ = _tmp65_;
#line 473 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp66_, "button-release-event", (GCallback) ____lambda65__gtk_widget_button_release_event, self, 0);
#line 478 "../src/Indicator.vala"
		_tmp67_ = self->priv->volume_scale;
#line 478 "../src/Indicator.vala"
		g_signal_connect_object ((GtkWidget*) _tmp67_, "scroll-event", (GCallback) ____lambda66__gtk_widget_scroll_event, self, G_CONNECT_AFTER);
#line 487 "../src/Indicator.vala"
		_tmp68_ = self->priv->volume_scale;
#line 487 "../src/Indicator.vala"
		g_signal_connect_object ((GObject*) _tmp68_, "notify::active", (GCallback) _sound_indicator_on_volume_switch_change_g_object_notify, self, 0);
#line 489 "../src/Indicator.vala"
		_tmp69_ = self->priv->volume_scale;
#line 489 "../src/Indicator.vala"
		_tmp70_ = sound_widgets_scale_get_scale_widget (_tmp69_);
#line 489 "../src/Indicator.vala"
		_tmp71_ = _tmp70_;
#line 489 "../src/Indicator.vala"
		g_signal_connect_object ((GtkRange*) _tmp71_, "value-changed", (GCallback) ____lambda67__gtk_range_value_changed, self, 0);
#line 403 "../src/Indicator.vala"
		_g_object_unref0 (settings_button);
#line 2549 "Indicator.c"
	}
#line 500 "../src/Indicator.vala"
	_tmp72_ = self->priv->main_box;
#line 500 "../src/Indicator.vala"
	_tmp73_ = _g_object_ref0 ((GtkWidget*) _tmp72_);
#line 500 "../src/Indicator.vala"
	result = _tmp73_;
#line 500 "../src/Indicator.vala"
	return result;
#line 2559 "Indicator.c"
}

static gboolean
sound_indicator_handle_scroll_event (SoundIndicator* self,
                                     GdkEventScroll* e,
                                     gdouble* dir)
{
	gdouble _vala_dir = 0.0;
	gboolean natural_scroll = FALSE;
	GdkInputSource event_source = 0;
	GdkDevice* _tmp0_;
	GdkInputSource _tmp1_;
	GdkInputSource _tmp2_;
	gboolean result;
#line 511 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 511 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 512 "../src/Indicator.vala"
	_vala_dir = 0.0;
#line 514 "../src/Indicator.vala"
	_tmp0_ = gdk_event_get_source_device ((GdkEvent*) e);
#line 514 "../src/Indicator.vala"
	g_object_get (_tmp0_, "input-source", &_tmp1_, NULL);
#line 514 "../src/Indicator.vala"
	_tmp2_ = _tmp1_;
#line 514 "../src/Indicator.vala"
	event_source = _tmp2_;
#line 515 "../src/Indicator.vala"
	if (event_source == GDK_SOURCE_MOUSE) {
#line 2590 "Indicator.c"
		gboolean _tmp3_;
#line 516 "../src/Indicator.vala"
		_tmp3_ = self->priv->_natural_scroll_mouse;
#line 516 "../src/Indicator.vala"
		natural_scroll = _tmp3_;
#line 2596 "Indicator.c"
	} else {
#line 517 "../src/Indicator.vala"
		if (event_source == GDK_SOURCE_TOUCHPAD) {
#line 2600 "Indicator.c"
			gboolean _tmp4_;
#line 518 "../src/Indicator.vala"
			_tmp4_ = self->priv->_natural_scroll_touchpad;
#line 518 "../src/Indicator.vala"
			natural_scroll = _tmp4_;
#line 2606 "Indicator.c"
		} else {
#line 520 "../src/Indicator.vala"
			natural_scroll = FALSE;
#line 2610 "Indicator.c"
		}
	}
#line 523 "../src/Indicator.vala"
	switch (e->direction) {
#line 523 "../src/Indicator.vala"
		case GDK_SCROLL_SMOOTH:
#line 2617 "Indicator.c"
		{
			gdouble abs_x = 0.0;
			gdouble abs_y = 0.0;
#line 525 "../src/Indicator.vala"
			abs_x = MAX (fabs (e->delta_x), 0.0001);
#line 526 "../src/Indicator.vala"
			abs_y = MAX (fabs (e->delta_y), 0.0001);
#line 528 "../src/Indicator.vala"
			if ((abs_y / abs_x) > 2.0) {
#line 529 "../src/Indicator.vala"
				self->priv->total_y_delta = self->priv->total_y_delta + e->delta_y;
#line 2629 "Indicator.c"
			} else {
#line 530 "../src/Indicator.vala"
				if ((abs_x / abs_y) > 2.0) {
#line 531 "../src/Indicator.vala"
					self->priv->total_x_delta = self->priv->total_x_delta + e->delta_x;
#line 2635 "Indicator.c"
				}
			}
#line 534 "../src/Indicator.vala"
			break;
#line 2640 "Indicator.c"
		}
#line 523 "../src/Indicator.vala"
		case GDK_SCROLL_UP:
#line 2644 "Indicator.c"
		{
#line 537 "../src/Indicator.vala"
			self->priv->total_y_delta = -1.0;
#line 538 "../src/Indicator.vala"
			break;
#line 2650 "Indicator.c"
		}
#line 523 "../src/Indicator.vala"
		case GDK_SCROLL_DOWN:
#line 2654 "Indicator.c"
		{
#line 540 "../src/Indicator.vala"
			self->priv->total_y_delta = 1.0;
#line 541 "../src/Indicator.vala"
			break;
#line 2660 "Indicator.c"
		}
#line 523 "../src/Indicator.vala"
		case GDK_SCROLL_LEFT:
#line 2664 "Indicator.c"
		{
#line 543 "../src/Indicator.vala"
			self->priv->total_x_delta = -1.0;
#line 544 "../src/Indicator.vala"
			break;
#line 2670 "Indicator.c"
		}
#line 523 "../src/Indicator.vala"
		case GDK_SCROLL_RIGHT:
#line 2674 "Indicator.c"
		{
#line 546 "../src/Indicator.vala"
			self->priv->total_x_delta = 1.0;
#line 547 "../src/Indicator.vala"
			break;
#line 2680 "Indicator.c"
		}
		default:
		{
#line 549 "../src/Indicator.vala"
			break;
#line 2686 "Indicator.c"
		}
	}
#line 552 "../src/Indicator.vala"
	if (fabs (self->priv->total_y_delta) > 0.5) {
#line 2691 "Indicator.c"
		gdouble _tmp5_ = 0.0;
#line 553 "../src/Indicator.vala"
		if (natural_scroll) {
#line 553 "../src/Indicator.vala"
			_tmp5_ = self->priv->total_y_delta;
#line 2697 "Indicator.c"
		} else {
#line 553 "../src/Indicator.vala"
			_tmp5_ = -self->priv->total_y_delta;
#line 2701 "Indicator.c"
		}
#line 553 "../src/Indicator.vala"
		_vala_dir = _tmp5_;
#line 2705 "Indicator.c"
	} else {
#line 554 "../src/Indicator.vala"
		if (fabs (self->priv->total_x_delta) > 0.5) {
#line 2709 "Indicator.c"
			gdouble _tmp6_ = 0.0;
#line 555 "../src/Indicator.vala"
			if (natural_scroll) {
#line 555 "../src/Indicator.vala"
				_tmp6_ = -self->priv->total_x_delta;
#line 2715 "Indicator.c"
			} else {
#line 555 "../src/Indicator.vala"
				_tmp6_ = self->priv->total_x_delta;
#line 2719 "Indicator.c"
			}
#line 555 "../src/Indicator.vala"
			_vala_dir = _tmp6_;
#line 2723 "Indicator.c"
		}
	}
#line 558 "../src/Indicator.vala"
	if (fabs (_vala_dir) > 0.0) {
#line 559 "../src/Indicator.vala"
		self->priv->total_y_delta = 0.0;
#line 560 "../src/Indicator.vala"
		self->priv->total_x_delta = 0.0;
#line 561 "../src/Indicator.vala"
		result = TRUE;
#line 561 "../src/Indicator.vala"
		if (dir) {
#line 561 "../src/Indicator.vala"
			*dir = _vala_dir;
#line 2738 "Indicator.c"
		}
#line 561 "../src/Indicator.vala"
		return result;
#line 2742 "Indicator.c"
	}
#line 564 "../src/Indicator.vala"
	result = FALSE;
#line 564 "../src/Indicator.vala"
	if (dir) {
#line 564 "../src/Indicator.vala"
		*dir = _vala_dir;
#line 2750 "Indicator.c"
	}
#line 564 "../src/Indicator.vala"
	return result;
#line 2754 "Indicator.c"
}

static void
sound_indicator_handle_change (SoundIndicator* self,
                               gdouble change,
                               gboolean is_mic)
{
	gdouble v = 0.0;
	gdouble new_v = 0.0;
	gint _tmp6_;
#line 567 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 570 "../src/Indicator.vala"
	if (is_mic) {
#line 2769 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp0_;
		gdouble _tmp1_;
		gdouble _tmp2_;
#line 571 "../src/Indicator.vala"
		_tmp0_ = self->priv->volume_control;
#line 571 "../src/Indicator.vala"
		_tmp1_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp0_);
#line 571 "../src/Indicator.vala"
		_tmp2_ = _tmp1_;
#line 571 "../src/Indicator.vala"
		v = _tmp2_;
#line 2781 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp3_;
		SoundServicesVolumeControlVolume* _tmp4_;
		SoundServicesVolumeControlVolume* _tmp5_;
#line 573 "../src/Indicator.vala"
		_tmp3_ = self->priv->volume_control;
#line 573 "../src/Indicator.vala"
		_tmp4_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp3_);
#line 573 "../src/Indicator.vala"
		_tmp5_ = _tmp4_;
#line 573 "../src/Indicator.vala"
		v = _tmp5_->volume;
#line 2794 "Indicator.c"
	}
#line 576 "../src/Indicator.vala"
	_tmp6_ = self->priv->_volume_step;
#line 576 "../src/Indicator.vala"
	new_v = CLAMP (v + ((((gdouble) _tmp6_) * change) / 100.0), 0.0, self->priv->max_volume);
#line 578 "../src/Indicator.vala"
	if (new_v == v) {
#line 580 "../src/Indicator.vala"
		return;
#line 2804 "Indicator.c"
	}
#line 583 "../src/Indicator.vala"
	if (is_mic) {
#line 2808 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp7_;
#line 584 "../src/Indicator.vala"
		_tmp7_ = self->priv->volume_control;
#line 584 "../src/Indicator.vala"
		sound_services_volume_control_set_mic_volume ((SoundServicesVolumeControl*) _tmp7_, new_v);
#line 2814 "Indicator.c"
	} else {
		SoundServicesVolumeControlVolume* vol = NULL;
		SoundServicesVolumeControlVolume* _tmp8_;
		SoundServicesVolumeControlVolume* _tmp9_;
		SoundServicesVolumeControlVolume* _tmp10_;
		SoundServicesVolumeControlPulse* _tmp11_;
		SoundServicesVolumeControlVolume* _tmp12_;
#line 586 "../src/Indicator.vala"
		_tmp8_ = sound_services_volume_control_volume_new ();
#line 586 "../src/Indicator.vala"
		vol = _tmp8_;
#line 587 "../src/Indicator.vala"
		_tmp9_ = vol;
#line 587 "../src/Indicator.vala"
		_tmp9_->reason = SOUND_SERVICES_VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS;
#line 588 "../src/Indicator.vala"
		_tmp10_ = vol;
#line 588 "../src/Indicator.vala"
		_tmp10_->volume = new_v;
#line 589 "../src/Indicator.vala"
		_tmp11_ = self->priv->volume_control;
#line 589 "../src/Indicator.vala"
		_tmp12_ = vol;
#line 589 "../src/Indicator.vala"
		sound_services_volume_control_set_volume ((SoundServicesVolumeControl*) _tmp11_, _tmp12_);
#line 583 "../src/Indicator.vala"
		_g_object_unref0 (vol);
#line 2842 "Indicator.c"
	}
#line 592 "../src/Indicator.vala"
	sound_indicator_notify_change (self, is_mic);
#line 2846 "Indicator.c"
}

static void
sound_indicator_real_opened (WingpanelIndicator* base)
{
	SoundIndicator * self;
	SoundWidgetsPlayerList* _tmp0_;
	NotifyNotification* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 595 "../src/Indicator.vala"
	self = (SoundIndicator*) base;
#line 596 "../src/Indicator.vala"
	self->priv->open = TRUE;
#line 598 "../src/Indicator.vala"
	_tmp0_ = self->priv->mpris;
#line 598 "../src/Indicator.vala"
	sound_widgets_player_list_update_default_player (_tmp0_);
#line 600 "../src/Indicator.vala"
	_tmp1_ = self->priv->notification;
#line 600 "../src/Indicator.vala"
	if (_tmp1_ != NULL) {
#line 2868 "Indicator.c"
		{
			NotifyNotification* _tmp2_;
#line 602 "../src/Indicator.vala"
			_tmp2_ = self->priv->notification;
#line 602 "../src/Indicator.vala"
			notify_notification_close (_tmp2_, &_inner_error0_);
#line 602 "../src/Indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2877 "Indicator.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
#line 601 "../src/Indicator.vala"
			e = _inner_error0_;
#line 601 "../src/Indicator.vala"
			_inner_error0_ = NULL;
#line 604 "../src/Indicator.vala"
			_tmp3_ = e;
#line 604 "../src/Indicator.vala"
			_tmp4_ = _tmp3_->message;
#line 604 "../src/Indicator.vala"
			g_warning ("Indicator.vala:604: Unable to close sound notification: %s", _tmp4_);
#line 601 "../src/Indicator.vala"
			_g_error_free0 (e);
#line 2899 "Indicator.c"
		}
		__finally0:
#line 601 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 601 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 601 "../src/Indicator.vala"
			g_clear_error (&_inner_error0_);
#line 601 "../src/Indicator.vala"
			return;
#line 2910 "Indicator.c"
		}
#line 607 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->notification);
#line 607 "../src/Indicator.vala"
		self->priv->notification = NULL;
#line 2916 "Indicator.c"
	}
}

static void
sound_indicator_real_closed (WingpanelIndicator* base)
{
	SoundIndicator * self;
#line 611 "../src/Indicator.vala"
	self = (SoundIndicator*) base;
#line 612 "../src/Indicator.vala"
	self->priv->open = FALSE;
#line 613 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->notification);
#line 613 "../src/Indicator.vala"
	self->priv->notification = NULL;
#line 2932 "Indicator.c"
}

static void
sound_indicator_show_settings (SoundIndicator* self)
{
	GError* _inner_error0_ = NULL;
#line 616 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 617 "../src/Indicator.vala"
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
#line 2943 "Indicator.c"
	{
#line 620 "../src/Indicator.vala"
		g_app_info_launch_default_for_uri ("settings://sound", NULL, &_inner_error0_);
#line 620 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2949 "Indicator.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 619 "../src/Indicator.vala"
		e = _inner_error0_;
#line 619 "../src/Indicator.vala"
		_inner_error0_ = NULL;
#line 622 "../src/Indicator.vala"
		_tmp0_ = e;
#line 622 "../src/Indicator.vala"
		_tmp1_ = _tmp0_->message;
#line 622 "../src/Indicator.vala"
		g_warning ("Indicator.vala:622: %s\n", _tmp1_);
#line 619 "../src/Indicator.vala"
		_g_error_free0 (e);
#line 2971 "Indicator.c"
	}
	__finally0:
#line 619 "../src/Indicator.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 619 "../src/Indicator.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 619 "../src/Indicator.vala"
		g_clear_error (&_inner_error0_);
#line 619 "../src/Indicator.vala"
		return;
#line 2982 "Indicator.c"
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 627 "../src/Indicator.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 627 "../src/Indicator.vala"
	return _data1_;
#line 2993 "Indicator.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 627 "../src/Indicator.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 3003 "Indicator.c"
		SoundIndicator* self;
#line 627 "../src/Indicator.vala"
		self = _data1_->self;
#line 627 "../src/Indicator.vala"
		_g_object_unref0 (self);
#line 627 "../src/Indicator.vala"
		g_slice_free (Block1Data, _data1_);
#line 3011 "Indicator.c"
	}
}

static gboolean
__lambda57_ (Block1Data* _data1_)
{
	SoundIndicator* self;
	gboolean notification_showing = FALSE;
	gboolean result;
#line 632 "../src/Indicator.vala"
	self = _data1_->self;
#line 633 "../src/Indicator.vala"
	notification_showing = FALSE;
#line 635 "../src/Indicator.vala"
	if (!self->priv->open) {
#line 636 "../src/Indicator.vala"
		notification_showing = sound_indicator_show_notification (self, _data1_->is_mic);
#line 3029 "Indicator.c"
	}
#line 641 "../src/Indicator.vala"
	if (!notification_showing) {
#line 3033 "Indicator.c"
		ca_proplist* props = NULL;
		ca_proplist* _tmp0_ = NULL;
		ca_proplist* _tmp1_;
		ca_proplist* _tmp2_;
		ca_context* _tmp3_;
		ca_proplist* _tmp4_;
#line 643 "../src/Indicator.vala"
		ca_proplist_create (&_tmp0_);
#line 643 "../src/Indicator.vala"
		_ca_proplist_destroy0 (props);
#line 643 "../src/Indicator.vala"
		props = _tmp0_;
#line 644 "../src/Indicator.vala"
		_tmp1_ = props;
#line 644 "../src/Indicator.vala"
		ca_proplist_sets (_tmp1_, CA_PROP_CANBERRA_CACHE_CONTROL, "volatile");
#line 645 "../src/Indicator.vala"
		_tmp2_ = props;
#line 645 "../src/Indicator.vala"
		ca_proplist_sets (_tmp2_, CA_PROP_EVENT_ID, "audio-volume-change");
#line 646 "../src/Indicator.vala"
		_tmp3_ = self->priv->ca_context;
#line 646 "../src/Indicator.vala"
		_tmp4_ = props;
#line 646 "../src/Indicator.vala"
		ca_context_play_full (_tmp3_, (guint32) 0, _tmp4_, NULL, NULL);
#line 641 "../src/Indicator.vala"
		_ca_proplist_destroy0 (props);
#line 3062 "Indicator.c"
	}
#line 649 "../src/Indicator.vala"
	self->priv->notify_timeout_id = (guint) 0;
#line 650 "../src/Indicator.vala"
	result = FALSE;
#line 650 "../src/Indicator.vala"
	return result;
#line 3070 "Indicator.c"
}

static gboolean
___lambda57__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda57_ (self);
#line 632 "../src/Indicator.vala"
	return result;
#line 3080 "Indicator.c"
}

static void
sound_indicator_notify_change (SoundIndicator* self,
                               gboolean is_mic)
{
	Block1Data* _data1_;
#line 627 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/Indicator.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 627 "../src/Indicator.vala"
	_data1_->_ref_count_ = 1;
#line 627 "../src/Indicator.vala"
	_data1_->self = g_object_ref (self);
#line 627 "../src/Indicator.vala"
	_data1_->is_mic = is_mic;
#line 628 "../src/Indicator.vala"
	if (self->priv->notify_timeout_id > ((guint) 0)) {
#line 629 "../src/Indicator.vala"
		block1_data_unref (_data1_);
#line 629 "../src/Indicator.vala"
		_data1_ = NULL;
#line 629 "../src/Indicator.vala"
		return;
#line 3106 "Indicator.c"
	}
#line 632 "../src/Indicator.vala"
	self->priv->notify_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda57__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 627 "../src/Indicator.vala"
	block1_data_unref (_data1_);
#line 627 "../src/Indicator.vala"
	_data1_ = NULL;
#line 3114 "Indicator.c"
}

static gboolean
sound_indicator_show_notification (SoundIndicator* self,
                                   gboolean is_mic)
{
	NotifyNotification* _tmp0_;
	NotifyNotification* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 655 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 656 "../src/Indicator.vala"
	_tmp0_ = self->priv->notification;
#line 656 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 3131 "Indicator.c"
		NotifyNotification* _tmp1_;
		NotifyNotification* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
#line 657 "../src/Indicator.vala"
		_tmp1_ = notify_notification_new ("indicator-sound", "", "");
#line 657 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->notification);
#line 657 "../src/Indicator.vala"
		self->priv->notification = _tmp1_;
#line 658 "../src/Indicator.vala"
		_tmp2_ = self->priv->notification;
#line 658 "../src/Indicator.vala"
		_tmp3_ = g_variant_new_string ("indicator-sound");
#line 658 "../src/Indicator.vala"
		g_variant_ref_sink (_tmp3_);
#line 658 "../src/Indicator.vala"
		_tmp4_ = _tmp3_;
#line 658 "../src/Indicator.vala"
		notify_notification_set_hint (_tmp2_, "x-canonical-private-synchronous", _tmp4_);
#line 658 "../src/Indicator.vala"
		_g_variant_unref0 (_tmp4_);
#line 3154 "Indicator.c"
	}
#line 661 "../src/Indicator.vala"
	_tmp5_ = self->priv->notification;
#line 661 "../src/Indicator.vala"
	if (_tmp5_ != NULL) {
#line 3160 "Indicator.c"
		gchar* icon = NULL;
		NotifyNotification* _tmp20_;
		const gchar* _tmp21_;
		gint32 volume = 0;
		NotifyNotification* _tmp28_;
		GVariant* _tmp29_;
		GVariant* _tmp30_;
#line 664 "../src/Indicator.vala"
		if (is_mic) {
#line 3170 "Indicator.c"
			gboolean _tmp6_ = FALSE;
			SoundServicesVolumeControlPulse* _tmp7_;
			gdouble _tmp8_;
			gdouble _tmp9_;
#line 665 "../src/Indicator.vala"
			_tmp7_ = self->priv->volume_control;
#line 665 "../src/Indicator.vala"
			_tmp8_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp7_);
#line 665 "../src/Indicator.vala"
			_tmp9_ = _tmp8_;
#line 665 "../src/Indicator.vala"
			if (_tmp9_ <= ((gdouble) 0)) {
#line 665 "../src/Indicator.vala"
				_tmp6_ = TRUE;
#line 3185 "Indicator.c"
			} else {
				SoundServicesVolumeControlPulse* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 665 "../src/Indicator.vala"
				_tmp10_ = self->priv->volume_control;
#line 665 "../src/Indicator.vala"
				_tmp11_ = sound_services_volume_control_pulse_get_micMute (_tmp10_);
#line 665 "../src/Indicator.vala"
				_tmp12_ = _tmp11_;
#line 665 "../src/Indicator.vala"
				_tmp6_ = _tmp12_;
#line 3198 "Indicator.c"
			}
#line 665 "../src/Indicator.vala"
			if (_tmp6_) {
#line 3202 "Indicator.c"
				gchar* _tmp13_;
#line 666 "../src/Indicator.vala"
				_tmp13_ = g_strdup ("microphone-sensitivity-muted-symbolic");
#line 666 "../src/Indicator.vala"
				_g_free0 (icon);
#line 666 "../src/Indicator.vala"
				icon = _tmp13_;
#line 3210 "Indicator.c"
			} else {
				gchar* _tmp14_;
#line 668 "../src/Indicator.vala"
				_tmp14_ = g_strdup ("audio-input-microphone-symbolic");
#line 668 "../src/Indicator.vala"
				_g_free0 (icon);
#line 668 "../src/Indicator.vala"
				icon = _tmp14_;
#line 3219 "Indicator.c"
			}
		} else {
			SoundWidgetsScale* _tmp15_;
			GtkScale* _tmp16_;
			GtkScale* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 671 "../src/Indicator.vala"
			_tmp15_ = self->priv->volume_scale;
#line 671 "../src/Indicator.vala"
			_tmp16_ = sound_widgets_scale_get_scale_widget (_tmp15_);
#line 671 "../src/Indicator.vala"
			_tmp17_ = _tmp16_;
#line 671 "../src/Indicator.vala"
			_tmp18_ = sound_indicator_get_volume_icon (self, gtk_range_get_value ((GtkRange*) _tmp17_));
#line 671 "../src/Indicator.vala"
			_tmp19_ = g_strdup (_tmp18_);
#line 671 "../src/Indicator.vala"
			_g_free0 (icon);
#line 671 "../src/Indicator.vala"
			icon = _tmp19_;
#line 3241 "Indicator.c"
		}
#line 674 "../src/Indicator.vala"
		_tmp20_ = self->priv->notification;
#line 674 "../src/Indicator.vala"
		_tmp21_ = icon;
#line 674 "../src/Indicator.vala"
		notify_notification_update (_tmp20_, "indicator-sound", "", _tmp21_);
#line 677 "../src/Indicator.vala"
		if (is_mic) {
#line 3251 "Indicator.c"
			SoundServicesVolumeControlPulse* _tmp22_;
			gdouble _tmp23_;
			gdouble _tmp24_;
#line 678 "../src/Indicator.vala"
			_tmp22_ = self->priv->volume_control;
#line 678 "../src/Indicator.vala"
			_tmp23_ = sound_services_volume_control_get_mic_volume ((SoundServicesVolumeControl*) _tmp22_);
#line 678 "../src/Indicator.vala"
			_tmp24_ = _tmp23_;
#line 678 "../src/Indicator.vala"
			volume = (gint32) round ((_tmp24_ / self->priv->max_volume) * 100.0);
#line 3263 "Indicator.c"
		} else {
			SoundServicesVolumeControlPulse* _tmp25_;
			SoundServicesVolumeControlVolume* _tmp26_;
			SoundServicesVolumeControlVolume* _tmp27_;
#line 680 "../src/Indicator.vala"
			_tmp25_ = self->priv->volume_control;
#line 680 "../src/Indicator.vala"
			_tmp26_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp25_);
#line 680 "../src/Indicator.vala"
			_tmp27_ = _tmp26_;
#line 680 "../src/Indicator.vala"
			volume = (gint32) round ((_tmp27_->volume / self->priv->max_volume) * 100.0);
#line 3276 "Indicator.c"
		}
#line 683 "../src/Indicator.vala"
		_tmp28_ = self->priv->notification;
#line 683 "../src/Indicator.vala"
		_tmp29_ = g_variant_new_int32 (volume);
#line 683 "../src/Indicator.vala"
		g_variant_ref_sink (_tmp29_);
#line 683 "../src/Indicator.vala"
		_tmp30_ = _tmp29_;
#line 683 "../src/Indicator.vala"
		notify_notification_set_hint (_tmp28_, "value", _tmp30_);
#line 683 "../src/Indicator.vala"
		_g_variant_unref0 (_tmp30_);
#line 3290 "Indicator.c"
		{
			NotifyNotification* _tmp31_;
#line 686 "../src/Indicator.vala"
			_tmp31_ = self->priv->notification;
#line 686 "../src/Indicator.vala"
			notify_notification_show (_tmp31_, &_inner_error0_);
#line 686 "../src/Indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3299 "Indicator.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp32_;
			const gchar* _tmp33_;
#line 685 "../src/Indicator.vala"
			e = _inner_error0_;
#line 685 "../src/Indicator.vala"
			_inner_error0_ = NULL;
#line 688 "../src/Indicator.vala"
			_tmp32_ = e;
#line 688 "../src/Indicator.vala"
			_tmp33_ = _tmp32_->message;
#line 688 "../src/Indicator.vala"
			g_warning ("Indicator.vala:688: Unable to show sound notification: %s", _tmp33_);
#line 689 "../src/Indicator.vala"
			_g_object_unref0 (self->priv->notification);
#line 689 "../src/Indicator.vala"
			self->priv->notification = NULL;
#line 690 "../src/Indicator.vala"
			result = FALSE;
#line 690 "../src/Indicator.vala"
			_g_error_free0 (e);
#line 690 "../src/Indicator.vala"
			_g_free0 (icon);
#line 690 "../src/Indicator.vala"
			return result;
#line 3331 "Indicator.c"
		}
		__finally0:
#line 685 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3336 "Indicator.c"
			gboolean _tmp34_ = FALSE;
#line 685 "../src/Indicator.vala"
			_g_free0 (icon);
#line 685 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 685 "../src/Indicator.vala"
			g_clear_error (&_inner_error0_);
#line 685 "../src/Indicator.vala"
			return _tmp34_;
#line 3346 "Indicator.c"
		}
#line 661 "../src/Indicator.vala"
		_g_free0 (icon);
#line 3350 "Indicator.c"
	} else {
#line 693 "../src/Indicator.vala"
		result = FALSE;
#line 693 "../src/Indicator.vala"
		return result;
#line 3356 "Indicator.c"
	}
#line 696 "../src/Indicator.vala"
	result = TRUE;
#line 696 "../src/Indicator.vala"
	return result;
#line 3362 "Indicator.c"
}

static void
sound_indicator_update_tooltip (SoundIndicator* self)
{
	gdouble _tmp0_ = 0.0;
	SoundServicesVolumeControlPulse* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* description = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_ = NULL;
	SoundServicesVolumeControlPulse* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	gchar* accel_label = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	DisplayWidget* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
#line 699 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 701 "../src/Indicator.vala"
	_tmp1_ = self->priv->volume_control;
#line 701 "../src/Indicator.vala"
	_tmp2_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp1_);
#line 701 "../src/Indicator.vala"
	_tmp3_ = _tmp2_;
#line 701 "../src/Indicator.vala"
	if (_tmp3_) {
#line 701 "../src/Indicator.vala"
		_tmp0_ = (gdouble) 0;
#line 3399 "Indicator.c"
	} else {
		SoundServicesVolumeControlPulse* _tmp4_;
		SoundServicesVolumeControlVolume* _tmp5_;
		SoundServicesVolumeControlVolume* _tmp6_;
#line 701 "../src/Indicator.vala"
		_tmp4_ = self->priv->volume_control;
#line 701 "../src/Indicator.vala"
		_tmp5_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp4_);
#line 701 "../src/Indicator.vala"
		_tmp6_ = _tmp5_;
#line 701 "../src/Indicator.vala"
		_tmp0_ = _tmp6_->volume * 100;
#line 3412 "Indicator.c"
	}
#line 700 "../src/Indicator.vala"
	_tmp7_ = g_strdup_printf (_ ("Volume: %.0f%%"), _tmp0_);
#line 700 "../src/Indicator.vala"
	description = _tmp7_;
#line 703 "../src/Indicator.vala"
	_tmp9_ = self->priv->volume_control;
#line 703 "../src/Indicator.vala"
	_tmp10_ = sound_services_volume_control_get_mute ((SoundServicesVolumeControl*) _tmp9_);
#line 703 "../src/Indicator.vala"
	_tmp11_ = _tmp10_;
#line 703 "../src/Indicator.vala"
	if (_tmp11_) {
#line 703 "../src/Indicator.vala"
		_tmp8_ = _ ("Middle-click to unmute");
#line 3428 "Indicator.c"
	} else {
#line 703 "../src/Indicator.vala"
		_tmp8_ = _ ("Middle-click to mute");
#line 3432 "Indicator.c"
	}
#line 703 "../src/Indicator.vala"
	_tmp12_ = g_strdup (_tmp8_);
#line 703 "../src/Indicator.vala"
	accel_label = _tmp12_;
#line 705 "../src/Indicator.vala"
	_tmp13_ = accel_label;
#line 705 "../src/Indicator.vala"
	_tmp14_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _tmp13_);
#line 705 "../src/Indicator.vala"
	_g_free0 (accel_label);
#line 705 "../src/Indicator.vala"
	accel_label = _tmp14_;
#line 706 "../src/Indicator.vala"
	_tmp15_ = self->priv->display_widget;
#line 706 "../src/Indicator.vala"
	_tmp16_ = description;
#line 706 "../src/Indicator.vala"
	_tmp17_ = accel_label;
#line 706 "../src/Indicator.vala"
	_tmp18_ = g_strdup_printf ("%s\n%s", _tmp16_, _tmp17_);
#line 706 "../src/Indicator.vala"
	_tmp19_ = _tmp18_;
#line 706 "../src/Indicator.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp15_, _tmp19_);
#line 706 "../src/Indicator.vala"
	_g_free0 (_tmp19_);
#line 699 "../src/Indicator.vala"
	_g_free0 (accel_label);
#line 699 "../src/Indicator.vala"
	_g_free0 (description);
#line 3464 "Indicator.c"
}

gboolean
sound_indicator_get_is_in_session (SoundIndicator* self)
{
	gboolean result;
#line 19 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 19 "../src/Indicator.vala"
	result = self->priv->_is_in_session;
#line 19 "../src/Indicator.vala"
	return result;
#line 3477 "Indicator.c"
}

static void
sound_indicator_set_is_in_session (SoundIndicator* self,
                                   gboolean value)
{
	gboolean old_value;
#line 19 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/Indicator.vala"
	old_value = sound_indicator_get_is_in_session (self);
#line 19 "../src/Indicator.vala"
	if (old_value != value) {
#line 19 "../src/Indicator.vala"
		self->priv->_is_in_session = value;
#line 19 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_IS_IN_SESSION_PROPERTY]);
#line 3495 "Indicator.c"
	}
}

gboolean
sound_indicator_get_natural_scroll_touchpad (SoundIndicator* self)
{
	gboolean result;
#line 20 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20 "../src/Indicator.vala"
	result = self->priv->_natural_scroll_touchpad;
#line 20 "../src/Indicator.vala"
	return result;
#line 3509 "Indicator.c"
}

void
sound_indicator_set_natural_scroll_touchpad (SoundIndicator* self,
                                             gboolean value)
{
	gboolean old_value;
#line 20 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Indicator.vala"
	old_value = sound_indicator_get_natural_scroll_touchpad (self);
#line 20 "../src/Indicator.vala"
	if (old_value != value) {
#line 20 "../src/Indicator.vala"
		self->priv->_natural_scroll_touchpad = value;
#line 20 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY]);
#line 3527 "Indicator.c"
	}
}

gboolean
sound_indicator_get_natural_scroll_mouse (SoundIndicator* self)
{
	gboolean result;
#line 21 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 21 "../src/Indicator.vala"
	result = self->priv->_natural_scroll_mouse;
#line 21 "../src/Indicator.vala"
	return result;
#line 3541 "Indicator.c"
}

void
sound_indicator_set_natural_scroll_mouse (SoundIndicator* self,
                                          gboolean value)
{
	gboolean old_value;
#line 21 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Indicator.vala"
	old_value = sound_indicator_get_natural_scroll_mouse (self);
#line 21 "../src/Indicator.vala"
	if (old_value != value) {
#line 21 "../src/Indicator.vala"
		self->priv->_natural_scroll_mouse = value;
#line 21 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY]);
#line 3559 "Indicator.c"
	}
}

gint
sound_indicator_get_volume_step (SoundIndicator* self)
{
	gint result;
#line 22 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 22 "../src/Indicator.vala"
	result = self->priv->_volume_step;
#line 22 "../src/Indicator.vala"
	return result;
#line 3573 "Indicator.c"
}

void
sound_indicator_set_volume_step (SoundIndicator* self,
                                 gint value)
{
	gint old_value;
#line 22 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Indicator.vala"
	old_value = sound_indicator_get_volume_step (self);
#line 22 "../src/Indicator.vala"
	if (old_value != value) {
#line 22 "../src/Indicator.vala"
		self->priv->_volume_step = value;
#line 22 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_indicator_properties[SOUND_INDICATOR_VOLUME_STEP_PROPERTY]);
#line 3591 "Indicator.c"
	}
}

static void
_sound_indicator_on_volume_change_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 84 "../src/Indicator.vala"
	sound_indicator_on_volume_change ((SoundIndicator*) self);
#line 3602 "Indicator.c"
}

static void
_sound_indicator_on_mic_volume_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 85 "../src/Indicator.vala"
	sound_indicator_on_mic_volume_change ((SoundIndicator*) self);
#line 3612 "Indicator.c"
}

static void
_sound_indicator_on_mute_change_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 86 "../src/Indicator.vala"
	sound_indicator_on_mute_change ((SoundIndicator*) self);
#line 3622 "Indicator.c"
}

static void
_sound_indicator_on_mic_mute_change_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 87 "../src/Indicator.vala"
	sound_indicator_on_mic_mute_change ((SoundIndicator*) self);
#line 3632 "Indicator.c"
}

static void
_sound_indicator_on_is_playing_change_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 88 "../src/Indicator.vala"
	sound_indicator_on_is_playing_change ((SoundIndicator*) self);
#line 3642 "Indicator.c"
}

static void
_sound_indicator_update_mic_visibility_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 89 "../src/Indicator.vala"
	sound_indicator_update_mic_visibility ((SoundIndicator*) self);
#line 3652 "Indicator.c"
}

static void
_sound_indicator_update_tooltip_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 92 "../src/Indicator.vala"
	sound_indicator_update_tooltip ((SoundIndicator*) self);
#line 3662 "Indicator.c"
}

static void
_sound_indicator_set_max_volume_g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 104 "../src/Indicator.vala"
	sound_indicator_set_max_volume ((SoundIndicator*) self);
#line 3672 "Indicator.c"
}

static void
_sound_indicator___lambda68_ (SoundIndicator* self,
                              GdkEventButton* e)
{
#line 108 "../src/Indicator.vala"
	g_return_if_fail (e != NULL);
#line 109 "../src/Indicator.vala"
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 3683 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp0_;
#line 110 "../src/Indicator.vala"
		_tmp0_ = self->priv->volume_control;
#line 110 "../src/Indicator.vala"
		sound_services_volume_control_pulse_toggle_mute (_tmp0_);
#line 3689 "Indicator.c"
	}
}

static void
__sound_indicator___lambda68__display_widget_volume_press_event (DisplayWidget* _sender,
                                                                 GdkEventButton* e,
                                                                 gpointer self)
{
#line 108 "../src/Indicator.vala"
	_sound_indicator___lambda68_ ((SoundIndicator*) self, e);
#line 3700 "Indicator.c"
}

static void
_sound_indicator___lambda69_ (SoundIndicator* self,
                              GdkEventButton* e)
{
#line 114 "../src/Indicator.vala"
	g_return_if_fail (e != NULL);
#line 115 "../src/Indicator.vala"
	if (e->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 3711 "Indicator.c"
		SoundServicesVolumeControlPulse* _tmp0_;
#line 116 "../src/Indicator.vala"
		_tmp0_ = self->priv->volume_control;
#line 116 "../src/Indicator.vala"
		sound_services_volume_control_pulse_toggle_mic_mute (_tmp0_);
#line 3717 "Indicator.c"
	}
}

static void
__sound_indicator___lambda69__display_widget_mic_press_event (DisplayWidget* _sender,
                                                              GdkEventButton* e,
                                                              gpointer self)
{
#line 114 "../src/Indicator.vala"
	_sound_indicator___lambda69_ ((SoundIndicator*) self, e);
#line 3728 "Indicator.c"
}

static void
_sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event (DisplayWidget* _sender,
                                                                                 GdkEventScroll* e,
                                                                                 gpointer self)
{
#line 122 "../src/Indicator.vala"
	sound_indicator_on_volume_icon_scroll_event ((SoundIndicator*) self, e);
#line 3738 "Indicator.c"
}

static void
_sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event (DisplayWidget* _sender,
                                                                           GdkEventScroll* e,
                                                                           gpointer self)
{
#line 123 "../src/Indicator.vala"
	sound_indicator_on_mic_icon_scroll_event ((SoundIndicator*) self, e);
#line 3748 "Indicator.c"
}

static void
_sound_indicator_on_watch_gbus_name_appeared_callback (GDBusConnection* connection,
                                                       const gchar* name,
                                                       const gchar* name_owner,
                                                       gpointer self)
{
#line 137 "../src/Indicator.vala"
	sound_indicator_on_watch ((SoundIndicator*) self, connection);
#line 3759 "Indicator.c"
}

static void
_sound_indicator_on_unwatch_gbus_name_vanished_callback (GDBusConnection* connection,
                                                         const gchar* name,
                                                         gpointer self)
{
#line 137 "../src/Indicator.vala"
	sound_indicator_on_unwatch ((SoundIndicator*) self, connection);
#line 3769 "Indicator.c"
}

static void
_sound_indicator___lambda70_ (SoundIndicator* self,
                              const gchar* key)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ShellKeyGrabber* _tmp2_;
#line 139 "../src/Indicator.vala"
	g_return_if_fail (key != NULL);
#line 140 "../src/Indicator.vala"
	if (g_strcmp0 (key, "volume-up") != 0) {
#line 141 "../src/Indicator.vala"
		_tmp1_ = g_strcmp0 (key, "volume-down") != 0;
#line 3785 "Indicator.c"
	} else {
#line 140 "../src/Indicator.vala"
		_tmp1_ = FALSE;
#line 3789 "Indicator.c"
	}
#line 140 "../src/Indicator.vala"
	if (_tmp1_) {
#line 142 "../src/Indicator.vala"
		_tmp0_ = g_strcmp0 (key, "volume-mute") != 0;
#line 3795 "Indicator.c"
	} else {
#line 140 "../src/Indicator.vala"
		_tmp0_ = FALSE;
#line 3799 "Indicator.c"
	}
#line 140 "../src/Indicator.vala"
	if (_tmp0_) {
#line 143 "../src/Indicator.vala"
		return;
#line 3805 "Indicator.c"
	}
#line 146 "../src/Indicator.vala"
	_tmp2_ = self->priv->key_grabber;
#line 146 "../src/Indicator.vala"
	if (_tmp2_ != NULL) {
#line 147 "../src/Indicator.vala"
		sound_indicator_ungrab_keybindings (self);
#line 148 "../src/Indicator.vala"
		sound_indicator_setup_grabs (self);
#line 3815 "Indicator.c"
	}
}

static void
__sound_indicator___lambda70__g_settings_changed (GSettings* _sender,
                                                  const gchar* key,
                                                  gpointer self)
{
#line 139 "../src/Indicator.vala"
	_sound_indicator___lambda70_ ((SoundIndicator*) self, key);
#line 3826 "Indicator.c"
}

static GObject *
sound_indicator_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundIndicator * self;
	GSettings* touchpad_settings = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* mouse_settings = NULL;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* gnome_settings = NULL;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GtkIconTheme* _tmp6_;
	DisplayWidget* _tmp7_;
	SoundServicesVolumeControlPulse* _tmp8_;
	SoundServicesVolumeControlPulse* _tmp9_;
	SoundServicesVolumeControlPulse* _tmp10_;
	SoundServicesVolumeControlPulse* _tmp11_;
	SoundServicesVolumeControlPulse* _tmp12_;
	SoundServicesVolumeControlPulse* _tmp13_;
	SoundServicesVolumeControlPulse* _tmp14_;
	SoundServicesVolumeControlPulse* _tmp15_;
	SoundServicesVolumeControlPulse* _tmp16_;
	SoundWidgetsDeviceManagerWidget* _tmp17_ = NULL;
	SoundWidgetsDeviceManagerWidget* _tmp18_ = NULL;
	GSettings* _tmp19_;
	gchar* locale = NULL;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	DisplayWidget* _tmp22_;
	DisplayWidget* _tmp23_;
	DisplayWidget* _tmp24_;
	SoundServicesVolumeControlPulse* _tmp25_;
	SoundServicesVolumeControlVolume* _tmp26_;
	SoundServicesVolumeControlVolume* _tmp27_;
	const gchar* _tmp28_;
	DisplayWidget* _tmp29_;
	DisplayWidget* _tmp30_;
	SoundWidgetsScale* _tmp31_;
	SoundWidgetsScale* _tmp32_;
	ca_context* _tmp33_;
	ca_context* _tmp34_;
	const gchar* _tmp35_;
	ca_context* _tmp36_;
	GSettings* _tmp37_;
#line 64 "../src/Indicator.vala"
	parent_class = G_OBJECT_CLASS (sound_indicator_parent_class);
#line 64 "../src/Indicator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 64 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INDICATOR, SoundIndicator);
#line 65 "../src/Indicator.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 66 "../src/Indicator.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 68 "../src/Indicator.vala"
	_tmp0_ = g_settings_new ("org.gnome.desktop.peripherals.touchpad");
#line 68 "../src/Indicator.vala"
	touchpad_settings = _tmp0_;
#line 69 "../src/Indicator.vala"
	_tmp1_ = touchpad_settings;
#line 69 "../src/Indicator.vala"
	g_settings_bind (_tmp1_, "natural-scroll", (GObject*) self, "natural-scroll-touchpad", G_SETTINGS_BIND_DEFAULT);
#line 70 "../src/Indicator.vala"
	_tmp2_ = g_settings_new ("org.gnome.desktop.peripherals.mouse");
#line 70 "../src/Indicator.vala"
	mouse_settings = _tmp2_;
#line 71 "../src/Indicator.vala"
	_tmp3_ = mouse_settings;
#line 71 "../src/Indicator.vala"
	g_settings_bind (_tmp3_, "natural-scroll", (GObject*) self, "natural-scroll-mouse", G_SETTINGS_BIND_DEFAULT);
#line 72 "../src/Indicator.vala"
	_tmp4_ = g_settings_new ("org.gnome.settings-daemon.plugins.media-keys");
#line 72 "../src/Indicator.vala"
	gnome_settings = _tmp4_;
#line 73 "../src/Indicator.vala"
	_tmp5_ = gnome_settings;
#line 73 "../src/Indicator.vala"
	g_settings_bind (_tmp5_, "volume-step", (GObject*) self, "volume-step", G_SETTINGS_BIND_DEFAULT);
#line 75 "../src/Indicator.vala"
	wingpanel_indicator_set_visible ((WingpanelIndicator*) self, TRUE);
#line 79 "../src/Indicator.vala"
	_tmp6_ = gtk_icon_theme_get_default ();
#line 79 "../src/Indicator.vala"
	gtk_icon_theme_add_resource_path (_tmp6_, "/org/elementary/wingpanel/icons");
#line 81 "../src/Indicator.vala"
	_tmp7_ = display_widget_new ();
#line 81 "../src/Indicator.vala"
	g_object_ref_sink (_tmp7_);
#line 81 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 81 "../src/Indicator.vala"
	self->priv->display_widget = _tmp7_;
#line 83 "../src/Indicator.vala"
	_tmp8_ = sound_services_volume_control_pulse_new ();
#line 83 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->volume_control);
#line 83 "../src/Indicator.vala"
	self->priv->volume_control = _tmp8_;
#line 84 "../src/Indicator.vala"
	_tmp9_ = self->priv->volume_control;
#line 84 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify::volume", (GCallback) _sound_indicator_on_volume_change_g_object_notify, self, 0);
#line 85 "../src/Indicator.vala"
	_tmp10_ = self->priv->volume_control;
#line 85 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp10_, "notify::mic-volume", (GCallback) _sound_indicator_on_mic_volume_change_g_object_notify, self, 0);
#line 86 "../src/Indicator.vala"
	_tmp11_ = self->priv->volume_control;
#line 86 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp11_, "notify::mute", (GCallback) _sound_indicator_on_mute_change_g_object_notify, self, 0);
#line 87 "../src/Indicator.vala"
	_tmp12_ = self->priv->volume_control;
#line 87 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp12_, "notify::micMute", (GCallback) _sound_indicator_on_mic_mute_change_g_object_notify, self, 0);
#line 88 "../src/Indicator.vala"
	_tmp13_ = self->priv->volume_control;
#line 88 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::is-playing", (GCallback) _sound_indicator_on_is_playing_change_g_object_notify, self, 0);
#line 89 "../src/Indicator.vala"
	_tmp14_ = self->priv->volume_control;
#line 89 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp14_, "notify::is-listening", (GCallback) _sound_indicator_update_mic_visibility_g_object_notify, self, 0);
#line 92 "../src/Indicator.vala"
	_tmp15_ = self->priv->volume_control;
#line 92 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::volume", (GCallback) _sound_indicator_update_tooltip_g_object_notify, self, 0);
#line 93 "../src/Indicator.vala"
	_tmp16_ = self->priv->volume_control;
#line 93 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp16_, "notify::mute", (GCallback) _sound_indicator_update_tooltip_g_object_notify, self, 0);
#line 95 "../src/Indicator.vala"
	_tmp17_ = sound_widgets_device_manager_widget_new ();
#line 95 "../src/Indicator.vala"
	_tmp17_->is_input_manager = FALSE;
#line 95 "../src/Indicator.vala"
	g_object_ref_sink (_tmp17_);
#line 95 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->output_device_manager);
#line 95 "../src/Indicator.vala"
	self->priv->output_device_manager = _tmp17_;
#line 98 "../src/Indicator.vala"
	_tmp18_ = sound_widgets_device_manager_widget_new ();
#line 98 "../src/Indicator.vala"
	_tmp18_->is_input_manager = TRUE;
#line 98 "../src/Indicator.vala"
	g_object_ref_sink (_tmp18_);
#line 98 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->input_device_manager);
#line 98 "../src/Indicator.vala"
	self->priv->input_device_manager = _tmp18_;
#line 102 "../src/Indicator.vala"
	notify_init ("wingpanel-indicator-sound");
#line 104 "../src/Indicator.vala"
	_tmp19_ = sound_indicator_settings;
#line 104 "../src/Indicator.vala"
	g_signal_connect_object ((GObject*) _tmp19_, "notify::max-volume", (GCallback) _sound_indicator_set_max_volume_g_object_notify, self, 0);
#line 106 "../src/Indicator.vala"
	_tmp20_ = setlocale (LC_MESSAGES, NULL);
#line 106 "../src/Indicator.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 106 "../src/Indicator.vala"
	locale = _tmp21_;
#line 108 "../src/Indicator.vala"
	_tmp22_ = self->priv->display_widget;
#line 108 "../src/Indicator.vala"
	g_signal_connect_object (_tmp22_, "volume-press-event", (GCallback) __sound_indicator___lambda68__display_widget_volume_press_event, self, 0);
#line 114 "../src/Indicator.vala"
	_tmp23_ = self->priv->display_widget;
#line 114 "../src/Indicator.vala"
	g_signal_connect_object (_tmp23_, "mic-press-event", (GCallback) __sound_indicator___lambda69__display_widget_mic_press_event, self, 0);
#line 120 "../src/Indicator.vala"
	_tmp24_ = self->priv->display_widget;
#line 120 "../src/Indicator.vala"
	_tmp25_ = self->priv->volume_control;
#line 120 "../src/Indicator.vala"
	_tmp26_ = sound_services_volume_control_get_volume ((SoundServicesVolumeControl*) _tmp25_);
#line 120 "../src/Indicator.vala"
	_tmp27_ = _tmp26_;
#line 120 "../src/Indicator.vala"
	_tmp28_ = sound_indicator_get_volume_icon (self, _tmp27_->volume);
#line 120 "../src/Indicator.vala"
	display_widget_set_icon_name (_tmp24_, _tmp28_);
#line 122 "../src/Indicator.vala"
	_tmp29_ = self->priv->display_widget;
#line 122 "../src/Indicator.vala"
	g_signal_connect_object (_tmp29_, "volume-scroll-event", (GCallback) _sound_indicator_on_volume_icon_scroll_event_display_widget_volume_scroll_event, self, G_CONNECT_AFTER);
#line 123 "../src/Indicator.vala"
	_tmp30_ = self->priv->display_widget;
#line 123 "../src/Indicator.vala"
	g_signal_connect_object (_tmp30_, "mic-scroll-event", (GCallback) _sound_indicator_on_mic_icon_scroll_event_display_widget_mic_scroll_event, self, G_CONNECT_AFTER);
#line 125 "../src/Indicator.vala"
	_tmp31_ = sound_widgets_scale_new ("audio-volume-high-symbolic", TRUE, 0.0, self->priv->max_volume, 0.01);
#line 125 "../src/Indicator.vala"
	g_object_ref_sink (_tmp31_);
#line 125 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 125 "../src/Indicator.vala"
	self->priv->volume_scale = _tmp31_;
#line 127 "../src/Indicator.vala"
	_tmp32_ = sound_widgets_scale_new ("indicator-microphone-symbolic", TRUE, 0.0, 1.0, 0.01);
#line 127 "../src/Indicator.vala"
	g_object_ref_sink (_tmp32_);
#line 127 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->mic_scale);
#line 127 "../src/Indicator.vala"
	self->priv->mic_scale = _tmp32_;
#line 129 "../src/Indicator.vala"
	_tmp33_ = ca_gtk_context_get ();
#line 129 "../src/Indicator.vala"
	self->priv->ca_context = _tmp33_;
#line 130 "../src/Indicator.vala"
	_tmp34_ = self->priv->ca_context;
#line 130 "../src/Indicator.vala"
	_tmp35_ = locale;
#line 130 "../src/Indicator.vala"
	ca_context_change_props (_tmp34_, CA_PROP_APPLICATION_NAME, "indicator-sound", CA_PROP_APPLICATION_ID, "wingpanel-indicator-sound", CA_PROP_APPLICATION_NAME, "start-here", CA_PROP_APPLICATION_LANGUAGE, _tmp35_, NULL, NULL);
#line 135 "../src/Indicator.vala"
	_tmp36_ = self->priv->ca_context;
#line 135 "../src/Indicator.vala"
	ca_context_open (_tmp36_);
#line 137 "../src/Indicator.vala"
	g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, "org.gnome.Shell", G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_sound_indicator_on_watch_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _sound_indicator_on_watch_gbus_name_appeared_callback, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((_sound_indicator_on_unwatch_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _sound_indicator_on_unwatch_gbus_name_vanished_callback, g_object_ref (self), (GClosureNotify) g_object_unref)));
#line 139 "../src/Indicator.vala"
	_tmp37_ = sound_indicator_settings;
#line 139 "../src/Indicator.vala"
	g_signal_connect_object (_tmp37_, "changed", (GCallback) __sound_indicator___lambda70__g_settings_changed, self, 0);
#line 64 "../src/Indicator.vala"
	_g_free0 (locale);
#line 64 "../src/Indicator.vala"
	_g_object_unref0 (gnome_settings);
#line 64 "../src/Indicator.vala"
	_g_object_unref0 (mouse_settings);
#line 64 "../src/Indicator.vala"
	_g_object_unref0 (touchpad_settings);
#line 64 "../src/Indicator.vala"
	return obj;
#line 4071 "Indicator.c"
}

static void
sound_indicator_class_init (SoundIndicatorClass * klass,
                            gpointer klass_data)
{
	GSettings* _tmp0_;
#line 18 "../src/Indicator.vala"
	sound_indicator_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Indicator.vala"
	g_type_class_adjust_private_offset (klass, &SoundIndicator_private_offset);
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) sound_indicator_real_get_display_widget;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) sound_indicator_real_get_widget;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) sound_indicator_real_opened;
#line 18 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) sound_indicator_real_closed;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_indicator_get_property;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_indicator_set_property;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_indicator_constructor;
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_indicator_finalize;
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_IS_IN_SESSION_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_IS_IN_SESSION_PROPERTY] = g_param_spec_boolean ("is-in-session", "is-in-session", "is-in-session", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY] = g_param_spec_boolean ("natural-scroll-touchpad", "natural-scroll-touchpad", "natural-scroll-touchpad", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY] = g_param_spec_boolean ("natural-scroll-mouse", "natural-scroll-mouse", "natural-scroll-mouse", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_INDICATOR_VOLUME_STEP_PROPERTY, sound_indicator_properties[SOUND_INDICATOR_VOLUME_STEP_PROPERTY] = g_param_spec_int ("volume-step", "volume-step", "volume-step", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 61 "../src/Indicator.vala"
	_tmp0_ = g_settings_new ("io.elementary.desktop.wingpanel.sound");
#line 61 "../src/Indicator.vala"
	_g_object_unref0 (sound_indicator_settings);
#line 61 "../src/Indicator.vala"
	sound_indicator_settings = _tmp0_;
#line 4113 "Indicator.c"
}

static void
sound_indicator_instance_init (SoundIndicator * self,
                               gpointer klass)
{
	GeeHashMultiMap* _tmp0_;
#line 18 "../src/Indicator.vala"
	self->priv = sound_indicator_get_instance_private (self);
#line 35 "../src/Indicator.vala"
	self->priv->key_grabber = NULL;
#line 36 "../src/Indicator.vala"
	self->priv->key_grabber_id = (gulong) 0;
#line 37 "../src/Indicator.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 37 "../src/Indicator.vala"
	self->priv->saved_action_ids = _tmp0_;
#line 39 "../src/Indicator.vala"
	self->priv->open = FALSE;
#line 40 "../src/Indicator.vala"
	self->priv->mute_blocks_sound = FALSE;
#line 43 "../src/Indicator.vala"
	self->priv->max_volume = 1.0;
#line 45 "../src/Indicator.vala"
	self->priv->ca_context = NULL;
#line 48 "../src/Indicator.vala"
	self->priv->total_x_delta = (gdouble) 0;
#line 49 "../src/Indicator.vala"
	self->priv->total_y_delta = (gdouble) 0;
#line 626 "../src/Indicator.vala"
	self->priv->notify_timeout_id = (guint) 0;
#line 4145 "Indicator.c"
}

static void
sound_indicator_finalize (GObject * obj)
{
	SoundIndicator * self;
#line 18 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INDICATOR, SoundIndicator);
#line 250 "../src/Indicator.vala"
	if (self->priv->sound_was_blocked_timeout_id > ((guint) 0)) {
#line 251 "../src/Indicator.vala"
		g_source_remove (self->priv->sound_was_blocked_timeout_id);
#line 4158 "Indicator.c"
	}
#line 254 "../src/Indicator.vala"
	if (self->priv->notify_timeout_id > ((guint) 0)) {
#line 255 "../src/Indicator.vala"
		g_source_remove (self->priv->notify_timeout_id);
#line 4164 "Indicator.c"
	}
#line 24 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 25 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->main_box);
#line 26 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->mpris);
#line 27 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 28 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->mic_scale);
#line 29 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->output_device_manager);
#line 30 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->input_device_manager);
#line 31 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->mic_separator);
#line 32 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->notification);
#line 33 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->volume_control);
#line 35 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->key_grabber);
#line 37 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->saved_action_ids);
#line 18 "../src/Indicator.vala"
	G_OBJECT_CLASS (sound_indicator_parent_class)->finalize (obj);
#line 4192 "Indicator.c"
}

static GType
sound_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundIndicator), 0, (GInstanceInitFunc) sound_indicator_instance_init, NULL };
	GType sound_indicator_type_id;
	sound_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "SoundIndicator", &g_define_type_info, 0);
	SoundIndicator_private_offset = g_type_add_instance_private (sound_indicator_type_id, sizeof (SoundIndicatorPrivate));
	return sound_indicator_type_id;
}

GType
sound_indicator_get_type (void)
{
	static volatile gsize sound_indicator_type_id__once = 0;
	if (g_once_init_enter (&sound_indicator_type_id__once)) {
		GType sound_indicator_type_id;
		sound_indicator_type_id = sound_indicator_get_type_once ();
		g_once_init_leave (&sound_indicator_type_id__once, sound_indicator_type_id);
	}
	return sound_indicator_type_id__once;
}

static void
_vala_sound_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_INDICATOR, SoundIndicator);
#line 18 "../src/Indicator.vala"
	switch (property_id) {
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_IS_IN_SESSION_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_boolean (value, sound_indicator_get_is_in_session (self));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_boolean (value, sound_indicator_get_natural_scroll_touchpad (self));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_boolean (value, sound_indicator_get_natural_scroll_mouse (self));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_VOLUME_STEP_PROPERTY:
#line 18 "../src/Indicator.vala"
		g_value_set_int (value, sound_indicator_get_volume_step (self));
#line 18 "../src/Indicator.vala"
		break;
#line 4251 "Indicator.c"
		default:
#line 18 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Indicator.vala"
		break;
#line 4257 "Indicator.c"
	}
}

static void
_vala_sound_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SoundIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_INDICATOR, SoundIndicator);
#line 18 "../src/Indicator.vala"
	switch (property_id) {
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_IS_IN_SESSION_PROPERTY:
#line 18 "../src/Indicator.vala"
		sound_indicator_set_is_in_session (self, g_value_get_boolean (value));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY:
#line 18 "../src/Indicator.vala"
		sound_indicator_set_natural_scroll_touchpad (self, g_value_get_boolean (value));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY:
#line 18 "../src/Indicator.vala"
		sound_indicator_set_natural_scroll_mouse (self, g_value_get_boolean (value));
#line 18 "../src/Indicator.vala"
		break;
#line 18 "../src/Indicator.vala"
		case SOUND_INDICATOR_VOLUME_STEP_PROPERTY:
#line 18 "../src/Indicator.vala"
		sound_indicator_set_volume_step (self, g_value_get_int (value));
#line 18 "../src/Indicator.vala"
		break;
#line 4295 "Indicator.c"
		default:
#line 18 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Indicator.vala"
		break;
#line 4301 "Indicator.c"
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	SoundIndicator* indicator = NULL;
	SoundIndicator* _tmp0_;
	WingpanelIndicator* result;
#line 710 "../src/Indicator.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 711 "../src/Indicator.vala"
	g_debug ("Indicator.vala:711: Activating Sound Indicator");
#line 713 "../src/Indicator.vala"
	_tmp0_ = sound_indicator_new (server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION);
#line 713 "../src/Indicator.vala"
	indicator = _tmp0_;
#line 714 "../src/Indicator.vala"
	result = (WingpanelIndicator*) indicator;
#line 714 "../src/Indicator.vala"
	return result;
#line 4324 "Indicator.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

